/* SystemBackground.c generated by valac 0.56.14, the Vala compiler
 * generated from SystemBackground.vala, do not modify */

/*
 * Copyright 2014 Tom Beckmann
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <meta/meta-background-actor.h>
#include <clutter/clutter.h>
#include <glib.h>
#include <meta/meta-background.h>
#include <meta/display.h>
#include <meta/meta-background-content.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_SYSTEM_BACKGROUND (gala_system_background_get_type ())
#define GALA_SYSTEM_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SYSTEM_BACKGROUND, GalaSystemBackground))
#define GALA_SYSTEM_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SYSTEM_BACKGROUND, GalaSystemBackgroundClass))
#define GALA_IS_SYSTEM_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SYSTEM_BACKGROUND))
#define GALA_IS_SYSTEM_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SYSTEM_BACKGROUND))
#define GALA_SYSTEM_BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SYSTEM_BACKGROUND, GalaSystemBackgroundClass))

typedef struct _GalaSystemBackground GalaSystemBackground;
typedef struct _GalaSystemBackgroundClass GalaSystemBackgroundClass;
typedef struct _GalaSystemBackgroundPrivate GalaSystemBackgroundPrivate;
enum  {
	GALA_SYSTEM_BACKGROUND_0_PROPERTY,
	GALA_SYSTEM_BACKGROUND_BACKGROUND_ACTOR_PROPERTY,
	GALA_SYSTEM_BACKGROUND_NUM_PROPERTIES
};
static GParamSpec* gala_system_background_properties[GALA_SYSTEM_BACKGROUND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GalaSystemBackground {
	GObject parent_instance;
	GalaSystemBackgroundPrivate * priv;
};

struct _GalaSystemBackgroundClass {
	GObjectClass parent_class;
};

struct _GalaSystemBackgroundPrivate {
	MetaBackgroundActor* _background_actor;
};

static gint GalaSystemBackground_private_offset;
static gpointer gala_system_background_parent_class = NULL;
static MetaBackground* gala_system_background_system_background;
static MetaBackground* gala_system_background_system_background = NULL;

VALA_EXTERN GType gala_system_background_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaSystemBackground, g_object_unref)
VALA_EXTERN GalaSystemBackground* gala_system_background_new (MetaDisplay* display);
VALA_EXTERN GalaSystemBackground* gala_system_background_construct (GType object_type,
                                                        MetaDisplay* display);
VALA_EXTERN void gala_system_background_refresh (void);
VALA_EXTERN MetaBackgroundActor* gala_system_background_get_background_actor (GalaSystemBackground* self);
static void gala_system_background_set_background_actor (GalaSystemBackground* self,
                                                  MetaBackgroundActor* value);
static GObject * gala_system_background_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void gala_system_background_finalize (GObject * obj);
static GType gala_system_background_get_type_once (void);
static void _vala_gala_system_background_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_gala_system_background_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const ClutterColor GALA_SYSTEM_BACKGROUND_DEFAULT_BACKGROUND_COLOR = {(guint8) 0x2e, (guint8) 0x34, (guint8) 0x36, (guint8) 0xff};

static inline gpointer
gala_system_background_get_instance_private (GalaSystemBackground* self)
{
	return G_STRUCT_MEMBER_P (self, GalaSystemBackground_private_offset);
}

GalaSystemBackground*
gala_system_background_construct (GType object_type,
                                  MetaDisplay* display)
{
	GalaSystemBackground * self = NULL;
	MetaBackgroundActor* _tmp0_;
	MetaBackgroundActor* _tmp1_;
#line 14 "../src/Background/SystemBackground.vala"
	g_return_val_if_fail (display != NULL, NULL);
#line 15 "../src/Background/SystemBackground.vala"
	_tmp0_ = (MetaBackgroundActor*) meta_background_actor_new (display, 0);
#line 15 "../src/Background/SystemBackground.vala"
	g_object_ref_sink (_tmp0_);
#line 15 "../src/Background/SystemBackground.vala"
	_tmp1_ = _tmp0_;
#line 15 "../src/Background/SystemBackground.vala"
	self = (GalaSystemBackground*) g_object_new (object_type, "background-actor", _tmp1_, NULL);
#line 15 "../src/Background/SystemBackground.vala"
	_g_object_unref0 (_tmp1_);
#line 14 "../src/Background/SystemBackground.vala"
	return self;
#line 126 "SystemBackground.c"
}

GalaSystemBackground*
gala_system_background_new (MetaDisplay* display)
{
#line 14 "../src/Background/SystemBackground.vala"
	return gala_system_background_construct (GALA_TYPE_SYSTEM_BACKGROUND, display);
#line 134 "SystemBackground.c"
}

void
gala_system_background_refresh (void)
{
	MetaBackground* _tmp0_;
#line 32 "../src/Background/SystemBackground.vala"
	_tmp0_ = gala_system_background_system_background;
#line 32 "../src/Background/SystemBackground.vala"
	if (_tmp0_ != NULL) {
#line 145 "SystemBackground.c"
		MetaBackground* _tmp1_;
#line 33 "../src/Background/SystemBackground.vala"
		_tmp1_ = gala_system_background_system_background;
#line 33 "../src/Background/SystemBackground.vala"
		meta_background_set_color (_tmp1_, &GALA_SYSTEM_BACKGROUND_DEFAULT_BACKGROUND_COLOR);
#line 151 "SystemBackground.c"
	}
}

MetaBackgroundActor*
gala_system_background_get_background_actor (GalaSystemBackground* self)
{
	MetaBackgroundActor* result;
	MetaBackgroundActor* _tmp0_;
#line 10 "../src/Background/SystemBackground.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 10 "../src/Background/SystemBackground.vala"
	_tmp0_ = self->priv->_background_actor;
#line 10 "../src/Background/SystemBackground.vala"
	result = _tmp0_;
#line 10 "../src/Background/SystemBackground.vala"
	return result;
#line 168 "SystemBackground.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 10 "../src/Background/SystemBackground.vala"
	return self ? g_object_ref (self) : NULL;
#line 176 "SystemBackground.c"
}

static void
gala_system_background_set_background_actor (GalaSystemBackground* self,
                                             MetaBackgroundActor* value)
{
	MetaBackgroundActor* old_value;
#line 10 "../src/Background/SystemBackground.vala"
	g_return_if_fail (self != NULL);
#line 10 "../src/Background/SystemBackground.vala"
	old_value = gala_system_background_get_background_actor (self);
#line 10 "../src/Background/SystemBackground.vala"
	if (old_value != value) {
#line 190 "SystemBackground.c"
		MetaBackgroundActor* _tmp0_;
#line 10 "../src/Background/SystemBackground.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 10 "../src/Background/SystemBackground.vala"
		_g_object_unref0 (self->priv->_background_actor);
#line 10 "../src/Background/SystemBackground.vala"
		self->priv->_background_actor = _tmp0_;
#line 10 "../src/Background/SystemBackground.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_system_background_properties[GALA_SYSTEM_BACKGROUND_BACKGROUND_ACTOR_PROPERTY]);
#line 200 "SystemBackground.c"
	}
}

static GObject *
gala_system_background_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaSystemBackground * self;
	MetaBackground* _tmp0_;
	MetaBackgroundActor* _tmp7_;
	ClutterContent* _tmp8_;
	ClutterContent* _tmp9_;
	MetaBackground* _tmp10_;
#line 18 "../src/Background/SystemBackground.vala"
	parent_class = G_OBJECT_CLASS (gala_system_background_parent_class);
#line 18 "../src/Background/SystemBackground.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 18 "../src/Background/SystemBackground.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_SYSTEM_BACKGROUND, GalaSystemBackground);
#line 19 "../src/Background/SystemBackground.vala"
	_tmp0_ = gala_system_background_system_background;
#line 19 "../src/Background/SystemBackground.vala"
	if (_tmp0_ == NULL) {
#line 227 "SystemBackground.c"
		MetaBackgroundActor* _tmp1_;
		MetaDisplay* _tmp2_;
		MetaDisplay* _tmp3_;
		MetaDisplay* _tmp4_;
		MetaBackground* _tmp5_;
		MetaBackground* _tmp6_;
#line 20 "../src/Background/SystemBackground.vala"
		_tmp1_ = self->priv->_background_actor;
#line 20 "../src/Background/SystemBackground.vala"
		g_object_get (_tmp1_, "meta-display", &_tmp2_, NULL);
#line 20 "../src/Background/SystemBackground.vala"
		_tmp3_ = _tmp2_;
#line 20 "../src/Background/SystemBackground.vala"
		_tmp4_ = _tmp3_;
#line 20 "../src/Background/SystemBackground.vala"
		_tmp5_ = meta_background_new (_tmp4_);
#line 20 "../src/Background/SystemBackground.vala"
		_g_object_unref0 (gala_system_background_system_background);
#line 20 "../src/Background/SystemBackground.vala"
		gala_system_background_system_background = _tmp5_;
#line 20 "../src/Background/SystemBackground.vala"
		_g_object_unref0 (_tmp4_);
#line 21 "../src/Background/SystemBackground.vala"
		_tmp6_ = gala_system_background_system_background;
#line 21 "../src/Background/SystemBackground.vala"
		meta_background_set_color (_tmp6_, &GALA_SYSTEM_BACKGROUND_DEFAULT_BACKGROUND_COLOR);
#line 254 "SystemBackground.c"
	}
#line 24 "../src/Background/SystemBackground.vala"
	_tmp7_ = self->priv->_background_actor;
#line 24 "../src/Background/SystemBackground.vala"
	_tmp8_ = clutter_actor_get_content ((ClutterActor*) _tmp7_);
#line 24 "../src/Background/SystemBackground.vala"
	_tmp9_ = _tmp8_;
#line 24 "../src/Background/SystemBackground.vala"
	_tmp10_ = gala_system_background_system_background;
#line 24 "../src/Background/SystemBackground.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, meta_background_content_get_type (), MetaBackgroundContent), "background", _tmp10_, NULL);
#line 18 "../src/Background/SystemBackground.vala"
	return obj;
#line 268 "SystemBackground.c"
}

static void
gala_system_background_class_init (GalaSystemBackgroundClass * klass,
                                   gpointer klass_data)
{
#line 7 "../src/Background/SystemBackground.vala"
	gala_system_background_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/Background/SystemBackground.vala"
	g_type_class_adjust_private_offset (klass, &GalaSystemBackground_private_offset);
#line 7 "../src/Background/SystemBackground.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_system_background_get_property;
#line 7 "../src/Background/SystemBackground.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_system_background_set_property;
#line 7 "../src/Background/SystemBackground.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_system_background_constructor;
#line 7 "../src/Background/SystemBackground.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_system_background_finalize;
#line 7 "../src/Background/SystemBackground.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SYSTEM_BACKGROUND_BACKGROUND_ACTOR_PROPERTY, gala_system_background_properties[GALA_SYSTEM_BACKGROUND_BACKGROUND_ACTOR_PROPERTY] = g_param_spec_object ("background-actor", "background-actor", "background-actor", meta_background_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 289 "SystemBackground.c"
}

static void
gala_system_background_instance_init (GalaSystemBackground * self,
                                      gpointer klass)
{
#line 7 "../src/Background/SystemBackground.vala"
	self->priv = gala_system_background_get_instance_private (self);
#line 298 "SystemBackground.c"
}

static void
gala_system_background_finalize (GObject * obj)
{
	GalaSystemBackground * self;
#line 7 "../src/Background/SystemBackground.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_SYSTEM_BACKGROUND, GalaSystemBackground);
#line 10 "../src/Background/SystemBackground.vala"
	_g_object_unref0 (self->priv->_background_actor);
#line 7 "../src/Background/SystemBackground.vala"
	G_OBJECT_CLASS (gala_system_background_parent_class)->finalize (obj);
#line 311 "SystemBackground.c"
}

static GType
gala_system_background_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaSystemBackgroundClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_system_background_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaSystemBackground), 0, (GInstanceInitFunc) gala_system_background_instance_init, NULL };
	GType gala_system_background_type_id;
	gala_system_background_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaSystemBackground", &g_define_type_info, 0);
	GalaSystemBackground_private_offset = g_type_add_instance_private (gala_system_background_type_id, sizeof (GalaSystemBackgroundPrivate));
	return gala_system_background_type_id;
}

GType
gala_system_background_get_type (void)
{
	static volatile gsize gala_system_background_type_id__once = 0;
	if (g_once_init_enter (&gala_system_background_type_id__once)) {
		GType gala_system_background_type_id;
		gala_system_background_type_id = gala_system_background_get_type_once ();
		g_once_init_leave (&gala_system_background_type_id__once, gala_system_background_type_id);
	}
	return gala_system_background_type_id__once;
}

static void
_vala_gala_system_background_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GalaSystemBackground * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_SYSTEM_BACKGROUND, GalaSystemBackground);
#line 7 "../src/Background/SystemBackground.vala"
	switch (property_id) {
#line 7 "../src/Background/SystemBackground.vala"
		case GALA_SYSTEM_BACKGROUND_BACKGROUND_ACTOR_PROPERTY:
#line 7 "../src/Background/SystemBackground.vala"
		g_value_set_object (value, gala_system_background_get_background_actor (self));
#line 7 "../src/Background/SystemBackground.vala"
		break;
#line 352 "SystemBackground.c"
		default:
#line 7 "../src/Background/SystemBackground.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/Background/SystemBackground.vala"
		break;
#line 358 "SystemBackground.c"
	}
}

static void
_vala_gala_system_background_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GalaSystemBackground * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_SYSTEM_BACKGROUND, GalaSystemBackground);
#line 7 "../src/Background/SystemBackground.vala"
	switch (property_id) {
#line 7 "../src/Background/SystemBackground.vala"
		case GALA_SYSTEM_BACKGROUND_BACKGROUND_ACTOR_PROPERTY:
#line 7 "../src/Background/SystemBackground.vala"
		gala_system_background_set_background_actor (self, g_value_get_object (value));
#line 7 "../src/Background/SystemBackground.vala"
		break;
#line 378 "SystemBackground.c"
		default:
#line 7 "../src/Background/SystemBackground.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/Background/SystemBackground.vala"
		break;
#line 384 "SystemBackground.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 21 "../src/PluginManager.vala"
	if (mem && byte_size != 0) {
#line 21 "../src/PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 21 "../src/PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 399 "SystemBackground.c"
	} else {
#line 21 "../src/PluginManager.vala"
		new_mem = NULL;
#line 403 "SystemBackground.c"
	}
#line 21 "../src/PluginManager.vala"
	return new_mem;
#line 407 "SystemBackground.c"
}

