/* DwellClickTimer.c generated by valac 0.56.14, the Vala compiler
 * generated from DwellClickTimer.vala, do not modify */

/**/
/*  Copyright 2020 elementary, Inc. (https://elementary.io)*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <clutter/clutter.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <cogl/cogl.h>
#include <cairo-gobject.h>
#include <gio/gio.h>
#include "gala.h"
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <meta/display.h>
#include <meta/meta-plugin.h>
#include <meta/meta-cursor-tracker.h>
#include <graphene-gobject.h>

#define GALA_DWELL_CLICK_TIMER_BACKGROUND_OPACITY 0.7
#define GALA_DWELL_CLICK_TIMER_BORDER_WIDTH_PX 1
#define GALA_DWELL_CLICK_TIMER_START_ANGLE ((3 * G_PI) / 2)
#define GALA_DWELL_CLICK_TIMER_DELAY_TIMEOUT ((gdouble) 185)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_DWELL_CLICK_TIMER (gala_dwell_click_timer_get_type ())
#define GALA_DWELL_CLICK_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimer))
#define GALA_DWELL_CLICK_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimerClass))
#define GALA_IS_DWELL_CLICK_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DWELL_CLICK_TIMER))
#define GALA_IS_DWELL_CLICK_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DWELL_CLICK_TIMER))
#define GALA_DWELL_CLICK_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimerClass))

typedef struct _GalaDwellClickTimer GalaDwellClickTimer;
typedef struct _GalaDwellClickTimerClass GalaDwellClickTimerClass;
typedef struct _GalaDwellClickTimerPrivate GalaDwellClickTimerPrivate;
enum  {
	GALA_DWELL_CLICK_TIMER_0_PROPERTY,
	GALA_DWELL_CLICK_TIMER_WM_PROPERTY,
	GALA_DWELL_CLICK_TIMER_ANGLE_PROPERTY,
	GALA_DWELL_CLICK_TIMER_NUM_PROPERTIES
};
static GParamSpec* gala_dwell_click_timer_properties[GALA_DWELL_CLICK_TIMER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _GalaDwellClickTimer {
	ClutterActor parent_instance;
	GalaDwellClickTimerPrivate * priv;
};

struct _GalaDwellClickTimerClass {
	ClutterActorClass parent_class;
};

struct _GalaDwellClickTimerPrivate {
	gfloat scaling_factor;
	gint cursor_size;
	CoglPipeline* pipeline;
	ClutterPropertyTransition* transition;
	cairo_pattern_t* stroke_color;
	cairo_pattern_t* fill_color;
	GSettings* interface_settings;
	cairo_surface_t* surface;
	GalaWindowManager* _wm;
	gdouble _angle;
};

static gint GalaDwellClickTimer_private_offset;
static gpointer gala_dwell_click_timer_parent_class = NULL;
static ClutterAnimatableInterface * gala_dwell_click_timer_clutter_animatable_parent_iface = NULL;

VALA_EXTERN GType gala_dwell_click_timer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaDwellClickTimer, g_object_unref)
VALA_EXTERN GalaDwellClickTimer* gala_dwell_click_timer_new (GalaWindowManager* wm);
VALA_EXTERN GalaDwellClickTimer* gala_dwell_click_timer_construct (GType object_type,
                                                       GalaWindowManager* wm);
static void gala_dwell_click_timer_update_cursor_size (GalaDwellClickTimer* self,
                                                gfloat scale);
static void gala_dwell_click_timer_real_paint (ClutterActor* base,
                                        ClutterPaintContext* context);
VALA_EXTERN gdouble gala_dwell_click_timer_get_angle (GalaDwellClickTimer* self);
VALA_EXTERN void gala_internal_utils_get_theme_accent_color (GdkRGBA* result);
VALA_EXTERN gint gala_internal_utils_scale_to_int (gint value,
                                       gfloat scale_factor);
static gboolean gala_dwell_click_timer_real_interpolate_value (ClutterAnimatable* base,
                                                        const gchar* property_name,
                                                        ClutterInterval* interval,
                                                        gdouble progress,
                                                        GValue* value);
VALA_EXTERN GalaWindowManager* gala_dwell_click_timer_get_wm (GalaDwellClickTimer* self);
static void gala_dwell_click_timer_set_wm (GalaDwellClickTimer* self,
                                    GalaWindowManager* value);
VALA_EXTERN void gala_dwell_click_timer_set_angle (GalaDwellClickTimer* self,
                                       gdouble value);
static GObject * gala_dwell_click_timer_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _gala_dwell_click_timer___lambda131_ (GalaDwellClickTimer* self);
static void __gala_dwell_click_timer___lambda131__clutter_timeline_new_frame (ClutterTimeline* _sender,
                                                                       gint msecs,
                                                                       gpointer self);
static void _gala_dwell_click_timer___lambda132_ (GalaDwellClickTimer* self,
                                           ClutterInputDevice* device,
                                           ClutterPointerA11yTimeoutType type,
                                           guint timeout);
static void __gala_dwell_click_timer___lambda132__clutter_seat_ptr_a11y_timeout_started (ClutterSeat* _sender,
                                                                                  ClutterInputDevice* device,
                                                                                  ClutterPointerA11yTimeoutType timeout_type,
                                                                                  guint delay,
                                                                                  gpointer self);
static void _gala_dwell_click_timer___lambda133_ (GalaDwellClickTimer* self,
                                           ClutterInputDevice* device,
                                           ClutterPointerA11yTimeoutType type,
                                           gboolean clicked);
static void __gala_dwell_click_timer___lambda133__clutter_seat_ptr_a11y_timeout_stopped (ClutterSeat* _sender,
                                                                                  ClutterInputDevice* device,
                                                                                  ClutterPointerA11yTimeoutType timeout_type,
                                                                                  gboolean clicked,
                                                                                  gpointer self);
static void gala_dwell_click_timer_finalize (GObject * obj);
static GType gala_dwell_click_timer_get_type_once (void);
static void _vala_gala_dwell_click_timer_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_gala_dwell_click_timer_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_dwell_click_timer_get_instance_private (GalaDwellClickTimer* self)
{
	return G_STRUCT_MEMBER_P (self, GalaDwellClickTimer_private_offset);
}

GalaDwellClickTimer*
gala_dwell_click_timer_construct (GType object_type,
                                  GalaWindowManager* wm)
{
	GalaDwellClickTimer * self = NULL;
#line 46 "../src/Widgets/DwellClickTimer.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 47 "../src/Widgets/DwellClickTimer.vala"
	self = (GalaDwellClickTimer*) g_object_new (object_type, "wm", wm, NULL);
#line 46 "../src/Widgets/DwellClickTimer.vala"
	return self;
#line 185 "DwellClickTimer.c"
}

GalaDwellClickTimer*
gala_dwell_click_timer_new (GalaWindowManager* wm)
{
#line 46 "../src/Widgets/DwellClickTimer.vala"
	return gala_dwell_click_timer_construct (GALA_TYPE_DWELL_CLICK_TIMER, wm);
#line 193 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_update_cursor_size (GalaDwellClickTimer* self,
                                           gfloat scale)
{
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	cairo_surface_t* _tmp3_;
#line 94 "../src/Widgets/DwellClickTimer.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/Widgets/DwellClickTimer.vala"
	self->priv->scaling_factor = scale;
#line 97 "../src/Widgets/DwellClickTimer.vala"
	_tmp0_ = self->priv->interface_settings;
#line 97 "../src/Widgets/DwellClickTimer.vala"
	self->priv->cursor_size = (gint) ((g_settings_get_int (_tmp0_, "cursor-size") * self->priv->scaling_factor) * 1.25);
#line 99 "../src/Widgets/DwellClickTimer.vala"
	_tmp3_ = self->priv->surface;
#line 99 "../src/Widgets/DwellClickTimer.vala"
	if (_tmp3_ == NULL) {
#line 99 "../src/Widgets/DwellClickTimer.vala"
		_tmp2_ = TRUE;
#line 218 "DwellClickTimer.c"
	} else {
		cairo_surface_t* _tmp4_;
#line 99 "../src/Widgets/DwellClickTimer.vala"
		_tmp4_ = self->priv->surface;
#line 99 "../src/Widgets/DwellClickTimer.vala"
		_tmp2_ = cairo_image_surface_get_width (_tmp4_) != self->priv->cursor_size;
#line 225 "DwellClickTimer.c"
	}
#line 99 "../src/Widgets/DwellClickTimer.vala"
	if (_tmp2_) {
#line 99 "../src/Widgets/DwellClickTimer.vala"
		_tmp1_ = TRUE;
#line 231 "DwellClickTimer.c"
	} else {
		cairo_surface_t* _tmp5_;
#line 99 "../src/Widgets/DwellClickTimer.vala"
		_tmp5_ = self->priv->surface;
#line 99 "../src/Widgets/DwellClickTimer.vala"
		_tmp1_ = cairo_image_surface_get_height (_tmp5_) != self->priv->cursor_size;
#line 238 "DwellClickTimer.c"
	}
#line 99 "../src/Widgets/DwellClickTimer.vala"
	if (_tmp1_) {
#line 242 "DwellClickTimer.c"
		cairo_surface_t* _tmp6_;
#line 100 "../src/Widgets/DwellClickTimer.vala"
		_tmp6_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, self->priv->cursor_size, self->priv->cursor_size);
#line 100 "../src/Widgets/DwellClickTimer.vala"
		_cairo_surface_destroy0 (self->priv->surface);
#line 100 "../src/Widgets/DwellClickTimer.vala"
		self->priv->surface = _tmp6_;
#line 250 "DwellClickTimer.c"
	}
#line 103 "../src/Widgets/DwellClickTimer.vala"
	clutter_actor_set_size ((ClutterActor*) self, (gfloat) self->priv->cursor_size, (gfloat) self->priv->cursor_size);
#line 254 "DwellClickTimer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 147 "../src/Widgets/DwellClickTimer.vala"
	return self ? g_object_ref (self) : NULL;
#line 262 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_real_paint (ClutterActor* base,
                                   ClutterPaintContext* context)
{
	GalaDwellClickTimer * self;
	gdouble _tmp0_;
	GdkRGBA rgba = {0};
	GdkRGBA _tmp1_ = {0};
	GdkRGBA _tmp2_;
	GdkRGBA _tmp3_;
	GdkRGBA _tmp4_;
	cairo_pattern_t* _tmp5_;
	GdkRGBA _tmp6_;
	GdkRGBA _tmp7_;
	GdkRGBA _tmp8_;
	cairo_pattern_t* _tmp9_;
	gint radius = 0;
	gdouble end_angle = 0.0;
	gdouble _tmp10_;
	gint border_width = 0;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_t* _tmp14_;
	cairo_t* _tmp15_;
	cairo_t* _tmp16_;
	cairo_t* _tmp17_;
	cairo_t* _tmp18_;
	cairo_t* _tmp19_;
	cairo_t* _tmp20_;
	cairo_t* _tmp21_;
	cairo_t* _tmp22_;
	cairo_t* _tmp23_;
	cairo_t* _tmp24_;
	cairo_t* _tmp25_;
	cairo_t* _tmp26_;
	cairo_pattern_t* _tmp27_;
	cairo_t* _tmp28_;
	cairo_t* _tmp29_;
	cairo_t* _tmp30_;
	cairo_pattern_t* _tmp31_;
	cairo_t* _tmp32_;
	CoglContext* cogl_context = NULL;
	CoglFramebuffer* _tmp33_;
	CoglContext* _tmp34_;
	CoglContext* _tmp35_;
	GError* _inner_error0_ = NULL;
#line 106 "../src/Widgets/DwellClickTimer.vala"
	self = (GalaDwellClickTimer*) base;
#line 106 "../src/Widgets/DwellClickTimer.vala"
	g_return_if_fail (context != NULL);
#line 107 "../src/Widgets/DwellClickTimer.vala"
	_tmp0_ = self->priv->_angle;
#line 107 "../src/Widgets/DwellClickTimer.vala"
	if (_tmp0_ == ((gdouble) 0)) {
#line 108 "../src/Widgets/DwellClickTimer.vala"
		return;
#line 323 "DwellClickTimer.c"
	}
#line 111 "../src/Widgets/DwellClickTimer.vala"
	gala_internal_utils_get_theme_accent_color (&_tmp1_);
#line 111 "../src/Widgets/DwellClickTimer.vala"
	rgba = _tmp1_;
#line 114 "../src/Widgets/DwellClickTimer.vala"
	_tmp2_ = rgba;
#line 114 "../src/Widgets/DwellClickTimer.vala"
	_tmp3_ = rgba;
#line 114 "../src/Widgets/DwellClickTimer.vala"
	_tmp4_ = rgba;
#line 114 "../src/Widgets/DwellClickTimer.vala"
	_tmp5_ = cairo_pattern_create_rgb (_tmp2_.red, _tmp3_.green, _tmp4_.blue);
#line 114 "../src/Widgets/DwellClickTimer.vala"
	_cairo_pattern_destroy0 (self->priv->stroke_color);
#line 114 "../src/Widgets/DwellClickTimer.vala"
	self->priv->stroke_color = _tmp5_;
#line 115 "../src/Widgets/DwellClickTimer.vala"
	_tmp6_ = rgba;
#line 115 "../src/Widgets/DwellClickTimer.vala"
	_tmp7_ = rgba;
#line 115 "../src/Widgets/DwellClickTimer.vala"
	_tmp8_ = rgba;
#line 115 "../src/Widgets/DwellClickTimer.vala"
	_tmp9_ = cairo_pattern_create_rgba (_tmp6_.red, _tmp7_.green, _tmp8_.blue, GALA_DWELL_CLICK_TIMER_BACKGROUND_OPACITY);
#line 115 "../src/Widgets/DwellClickTimer.vala"
	_cairo_pattern_destroy0 (self->priv->fill_color);
#line 115 "../src/Widgets/DwellClickTimer.vala"
	self->priv->fill_color = _tmp9_;
#line 117 "../src/Widgets/DwellClickTimer.vala"
	radius = MIN (self->priv->cursor_size / 2, self->priv->cursor_size / 2);
#line 118 "../src/Widgets/DwellClickTimer.vala"
	_tmp10_ = self->priv->_angle;
#line 118 "../src/Widgets/DwellClickTimer.vala"
	end_angle = GALA_DWELL_CLICK_TIMER_START_ANGLE + _tmp10_;
#line 119 "../src/Widgets/DwellClickTimer.vala"
	border_width = gala_internal_utils_scale_to_int (GALA_DWELL_CLICK_TIMER_BORDER_WIDTH_PX, self->priv->scaling_factor);
#line 121 "../src/Widgets/DwellClickTimer.vala"
	_tmp11_ = self->priv->surface;
#line 121 "../src/Widgets/DwellClickTimer.vala"
	_tmp12_ = cairo_create (_tmp11_);
#line 121 "../src/Widgets/DwellClickTimer.vala"
	cr = _tmp12_;
#line 124 "../src/Widgets/DwellClickTimer.vala"
	_tmp13_ = cr;
#line 124 "../src/Widgets/DwellClickTimer.vala"
	cairo_save (_tmp13_);
#line 125 "../src/Widgets/DwellClickTimer.vala"
	_tmp14_ = cr;
#line 125 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_source_rgba (_tmp14_, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 126 "../src/Widgets/DwellClickTimer.vala"
	_tmp15_ = cr;
#line 126 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_operator (_tmp15_, CAIRO_OPERATOR_SOURCE);
#line 127 "../src/Widgets/DwellClickTimer.vala"
	_tmp16_ = cr;
#line 127 "../src/Widgets/DwellClickTimer.vala"
	cairo_paint (_tmp16_);
#line 128 "../src/Widgets/DwellClickTimer.vala"
	_tmp17_ = cr;
#line 128 "../src/Widgets/DwellClickTimer.vala"
	cairo_restore (_tmp17_);
#line 130 "../src/Widgets/DwellClickTimer.vala"
	_tmp18_ = cr;
#line 130 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_line_cap (_tmp18_, CAIRO_LINE_CAP_ROUND);
#line 131 "../src/Widgets/DwellClickTimer.vala"
	_tmp19_ = cr;
#line 131 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_line_join (_tmp19_, CAIRO_LINE_JOIN_ROUND);
#line 132 "../src/Widgets/DwellClickTimer.vala"
	_tmp20_ = cr;
#line 132 "../src/Widgets/DwellClickTimer.vala"
	cairo_translate (_tmp20_, (gdouble) (self->priv->cursor_size / 2), (gdouble) (self->priv->cursor_size / 2));
#line 134 "../src/Widgets/DwellClickTimer.vala"
	_tmp21_ = cr;
#line 134 "../src/Widgets/DwellClickTimer.vala"
	cairo_move_to (_tmp21_, (gdouble) 0, (gdouble) 0);
#line 135 "../src/Widgets/DwellClickTimer.vala"
	_tmp22_ = cr;
#line 135 "../src/Widgets/DwellClickTimer.vala"
	cairo_arc (_tmp22_, (gdouble) 0, (gdouble) 0, (gdouble) (radius - border_width), GALA_DWELL_CLICK_TIMER_START_ANGLE, end_angle);
#line 136 "../src/Widgets/DwellClickTimer.vala"
	_tmp23_ = cr;
#line 136 "../src/Widgets/DwellClickTimer.vala"
	cairo_line_to (_tmp23_, (gdouble) 0, (gdouble) 0);
#line 137 "../src/Widgets/DwellClickTimer.vala"
	_tmp24_ = cr;
#line 137 "../src/Widgets/DwellClickTimer.vala"
	cairo_close_path (_tmp24_);
#line 139 "../src/Widgets/DwellClickTimer.vala"
	_tmp25_ = cr;
#line 139 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_line_width (_tmp25_, (gdouble) 0);
#line 140 "../src/Widgets/DwellClickTimer.vala"
	_tmp26_ = cr;
#line 140 "../src/Widgets/DwellClickTimer.vala"
	_tmp27_ = self->priv->fill_color;
#line 140 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_source (_tmp26_, _tmp27_);
#line 141 "../src/Widgets/DwellClickTimer.vala"
	_tmp28_ = cr;
#line 141 "../src/Widgets/DwellClickTimer.vala"
	cairo_fill_preserve (_tmp28_);
#line 143 "../src/Widgets/DwellClickTimer.vala"
	_tmp29_ = cr;
#line 143 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_line_width (_tmp29_, (gdouble) border_width);
#line 144 "../src/Widgets/DwellClickTimer.vala"
	_tmp30_ = cr;
#line 144 "../src/Widgets/DwellClickTimer.vala"
	_tmp31_ = self->priv->stroke_color;
#line 144 "../src/Widgets/DwellClickTimer.vala"
	cairo_set_source (_tmp30_, _tmp31_);
#line 145 "../src/Widgets/DwellClickTimer.vala"
	_tmp32_ = cr;
#line 145 "../src/Widgets/DwellClickTimer.vala"
	cairo_stroke (_tmp32_);
#line 147 "../src/Widgets/DwellClickTimer.vala"
	_tmp33_ = clutter_paint_context_get_framebuffer (context);
#line 147 "../src/Widgets/DwellClickTimer.vala"
	_tmp34_ = cogl_framebuffer_get_context (_tmp33_);
#line 147 "../src/Widgets/DwellClickTimer.vala"
	_tmp35_ = _g_object_ref0 (_tmp34_);
#line 147 "../src/Widgets/DwellClickTimer.vala"
	cogl_context = _tmp35_;
#line 451 "DwellClickTimer.c"
	{
		CoglTexture2D* texture = NULL;
		CoglContext* _tmp36_;
		cairo_surface_t* _tmp37_;
		cairo_surface_t* _tmp38_;
		guchar* _tmp39_;
		CoglTexture2D* _tmp40_;
		CoglPipeline* _tmp41_;
		CoglTexture2D* _tmp42_;
		CoglFramebuffer* _tmp43_;
		CoglPipeline* _tmp44_;
#line 150 "../src/Widgets/DwellClickTimer.vala"
		_tmp36_ = cogl_context;
#line 150 "../src/Widgets/DwellClickTimer.vala"
		_tmp37_ = self->priv->surface;
#line 150 "../src/Widgets/DwellClickTimer.vala"
		_tmp38_ = self->priv->surface;
#line 150 "../src/Widgets/DwellClickTimer.vala"
		_tmp39_ = cairo_image_surface_get_data (_tmp38_);
#line 150 "../src/Widgets/DwellClickTimer.vala"
		_tmp40_ = (CoglTexture2D*) cogl_texture_2d_new_from_data (_tmp36_, self->priv->cursor_size, self->priv->cursor_size, COGL_PIXEL_FORMAT_BGRA_8888_PRE, cairo_image_surface_get_stride (_tmp37_), (const uint8_t*) _tmp39_, &_inner_error0_);
#line 150 "../src/Widgets/DwellClickTimer.vala"
		texture = _tmp40_;
#line 150 "../src/Widgets/DwellClickTimer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 477 "DwellClickTimer.c"
			goto __catch0_g_error;
		}
#line 153 "../src/Widgets/DwellClickTimer.vala"
		_tmp41_ = self->priv->pipeline;
#line 153 "../src/Widgets/DwellClickTimer.vala"
		_tmp42_ = texture;
#line 153 "../src/Widgets/DwellClickTimer.vala"
		cogl_pipeline_set_layer_texture (_tmp41_, 0, (CoglTexture*) _tmp42_);
#line 155 "../src/Widgets/DwellClickTimer.vala"
		_tmp43_ = clutter_paint_context_get_framebuffer (context);
#line 155 "../src/Widgets/DwellClickTimer.vala"
		_tmp44_ = self->priv->pipeline;
#line 155 "../src/Widgets/DwellClickTimer.vala"
		cogl_framebuffer_draw_rectangle (_tmp43_, _tmp44_, (gfloat) 0, (gfloat) 0, (gfloat) self->priv->cursor_size, (gfloat) self->priv->cursor_size);
#line 149 "../src/Widgets/DwellClickTimer.vala"
		_g_object_unref0 (texture);
#line 494 "DwellClickTimer.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 149 "../src/Widgets/DwellClickTimer.vala"
		g_clear_error (&_inner_error0_);
#line 501 "DwellClickTimer.c"
	}
	__finally0:
#line 149 "../src/Widgets/DwellClickTimer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "../src/Widgets/DwellClickTimer.vala"
		_g_object_unref0 (cogl_context);
#line 149 "../src/Widgets/DwellClickTimer.vala"
		_cairo_destroy0 (cr);
#line 149 "../src/Widgets/DwellClickTimer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/Widgets/DwellClickTimer.vala"
		g_clear_error (&_inner_error0_);
#line 149 "../src/Widgets/DwellClickTimer.vala"
		return;
#line 516 "DwellClickTimer.c"
	}
#line 158 "../src/Widgets/DwellClickTimer.vala"
	CLUTTER_ACTOR_CLASS (gala_dwell_click_timer_parent_class)->paint (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor), context);
#line 106 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (cogl_context);
#line 106 "../src/Widgets/DwellClickTimer.vala"
	_cairo_destroy0 (cr);
#line 524 "DwellClickTimer.c"
}

static gboolean
gala_dwell_click_timer_real_interpolate_value (ClutterAnimatable* base,
                                               const gchar* property_name,
                                               ClutterInterval* interval,
                                               gdouble progress,
                                               GValue* value)
{
	GalaDwellClickTimer * self;
	GValue _vala_value = {0};
	GValue _tmp6_ = {0};
	gboolean _tmp7_;
	gboolean result;
#line 161 "../src/Widgets/DwellClickTimer.vala"
	self = (GalaDwellClickTimer*) base;
#line 161 "../src/Widgets/DwellClickTimer.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 161 "../src/Widgets/DwellClickTimer.vala"
	g_return_val_if_fail (interval != NULL, FALSE);
#line 162 "../src/Widgets/DwellClickTimer.vala"
	if (g_strcmp0 (property_name, "angle") == 0) {
#line 547 "DwellClickTimer.c"
		GValue _tmp0_ = {0};
		guint elapsed_time = 0U;
		ClutterPropertyTransition* _tmp1_;
#line 163 "../src/Widgets/DwellClickTimer.vala"
		g_value_init (&_tmp0_, G_TYPE_INT);
#line 163 "../src/Widgets/DwellClickTimer.vala"
		g_value_set_int (&_tmp0_, 0);
#line 163 "../src/Widgets/DwellClickTimer.vala"
		G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 163 "../src/Widgets/DwellClickTimer.vala"
		_vala_value = _tmp0_;
#line 165 "../src/Widgets/DwellClickTimer.vala"
		_tmp1_ = self->priv->transition;
#line 165 "../src/Widgets/DwellClickTimer.vala"
		elapsed_time = clutter_timeline_get_elapsed_time ((ClutterTimeline*) _tmp1_);
#line 166 "../src/Widgets/DwellClickTimer.vala"
		if (((gdouble) elapsed_time) > GALA_DWELL_CLICK_TIMER_DELAY_TIMEOUT) {
#line 565 "DwellClickTimer.c"
			gdouble delayed_progress = 0.0;
			ClutterPropertyTransition* _tmp2_;
			guint _tmp3_;
			guint _tmp4_;
			GValue _tmp5_ = {0};
#line 167 "../src/Widgets/DwellClickTimer.vala"
			_tmp2_ = self->priv->transition;
#line 167 "../src/Widgets/DwellClickTimer.vala"
			_tmp3_ = clutter_timeline_get_duration ((ClutterTimeline*) _tmp2_);
#line 167 "../src/Widgets/DwellClickTimer.vala"
			_tmp4_ = _tmp3_;
#line 167 "../src/Widgets/DwellClickTimer.vala"
			delayed_progress = (elapsed_time - GALA_DWELL_CLICK_TIMER_DELAY_TIMEOUT) / (_tmp4_ - GALA_DWELL_CLICK_TIMER_DELAY_TIMEOUT);
#line 168 "../src/Widgets/DwellClickTimer.vala"
			g_value_init (&_tmp5_, G_TYPE_DOUBLE);
#line 168 "../src/Widgets/DwellClickTimer.vala"
			g_value_set_double (&_tmp5_, (delayed_progress * 2) * G_PI);
#line 168 "../src/Widgets/DwellClickTimer.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 168 "../src/Widgets/DwellClickTimer.vala"
			_vala_value = _tmp5_;
#line 587 "DwellClickTimer.c"
		}
#line 171 "../src/Widgets/DwellClickTimer.vala"
		result = TRUE;
#line 171 "../src/Widgets/DwellClickTimer.vala"
		if (value) {
#line 171 "../src/Widgets/DwellClickTimer.vala"
			*value = _vala_value;
#line 595 "DwellClickTimer.c"
		} else {
#line 171 "../src/Widgets/DwellClickTimer.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 599 "DwellClickTimer.c"
		}
#line 171 "../src/Widgets/DwellClickTimer.vala"
		return result;
#line 603 "DwellClickTimer.c"
	}
#line 174 "../src/Widgets/DwellClickTimer.vala"
	_tmp7_ = gala_dwell_click_timer_clutter_animatable_parent_iface->interpolate_value ((ClutterAnimatable*) G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor), property_name, interval, progress, &_tmp6_);
#line 174 "../src/Widgets/DwellClickTimer.vala"
	G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 174 "../src/Widgets/DwellClickTimer.vala"
	_vala_value = _tmp6_;
#line 174 "../src/Widgets/DwellClickTimer.vala"
	result = _tmp7_;
#line 174 "../src/Widgets/DwellClickTimer.vala"
	if (value) {
#line 174 "../src/Widgets/DwellClickTimer.vala"
		*value = _vala_value;
#line 617 "DwellClickTimer.c"
	} else {
#line 174 "../src/Widgets/DwellClickTimer.vala"
		G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 621 "DwellClickTimer.c"
	}
#line 174 "../src/Widgets/DwellClickTimer.vala"
	return result;
#line 625 "DwellClickTimer.c"
}

GalaWindowManager*
gala_dwell_click_timer_get_wm (GalaDwellClickTimer* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 42 "../src/Widgets/DwellClickTimer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/Widgets/DwellClickTimer.vala"
	_tmp0_ = self->priv->_wm;
#line 42 "../src/Widgets/DwellClickTimer.vala"
	result = _tmp0_;
#line 42 "../src/Widgets/DwellClickTimer.vala"
	return result;
#line 641 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_set_wm (GalaDwellClickTimer* self,
                               GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 42 "../src/Widgets/DwellClickTimer.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Widgets/DwellClickTimer.vala"
	old_value = gala_dwell_click_timer_get_wm (self);
#line 42 "../src/Widgets/DwellClickTimer.vala"
	if (old_value != value) {
#line 42 "../src/Widgets/DwellClickTimer.vala"
		self->priv->_wm = value;
#line 42 "../src/Widgets/DwellClickTimer.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_dwell_click_timer_properties[GALA_DWELL_CLICK_TIMER_WM_PROPERTY]);
#line 659 "DwellClickTimer.c"
	}
}

gdouble
gala_dwell_click_timer_get_angle (GalaDwellClickTimer* self)
{
	gdouble result;
#line 44 "../src/Widgets/DwellClickTimer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 44 "../src/Widgets/DwellClickTimer.vala"
	result = self->priv->_angle;
#line 44 "../src/Widgets/DwellClickTimer.vala"
	return result;
#line 673 "DwellClickTimer.c"
}

void
gala_dwell_click_timer_set_angle (GalaDwellClickTimer* self,
                                  gdouble value)
{
	gdouble old_value;
#line 44 "../src/Widgets/DwellClickTimer.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/Widgets/DwellClickTimer.vala"
	old_value = gala_dwell_click_timer_get_angle (self);
#line 44 "../src/Widgets/DwellClickTimer.vala"
	if (old_value != value) {
#line 44 "../src/Widgets/DwellClickTimer.vala"
		self->priv->_angle = value;
#line 44 "../src/Widgets/DwellClickTimer.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_dwell_click_timer_properties[GALA_DWELL_CLICK_TIMER_ANGLE_PROPERTY]);
#line 691 "DwellClickTimer.c"
	}
}

static void
_gala_dwell_click_timer___lambda131_ (GalaDwellClickTimer* self)
{
#line 63 "../src/Widgets/DwellClickTimer.vala"
	clutter_actor_queue_redraw ((ClutterActor*) self);
#line 700 "DwellClickTimer.c"
}

static void
__gala_dwell_click_timer___lambda131__clutter_timeline_new_frame (ClutterTimeline* _sender,
                                                                  gint msecs,
                                                                  gpointer self)
{
#line 62 "../src/Widgets/DwellClickTimer.vala"
	_gala_dwell_click_timer___lambda131_ ((GalaDwellClickTimer*) self);
#line 710 "DwellClickTimer.c"
}

static void
_gala_dwell_click_timer___lambda132_ (GalaDwellClickTimer* self,
                                      ClutterInputDevice* device,
                                      ClutterPointerA11yTimeoutType type,
                                      guint timeout)
{
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	gfloat scale = 0.0F;
	MetaDisplay* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaCursorTracker* tracker = NULL;
	MetaDisplay* _tmp4_;
	MetaCursorTracker* _tmp5_;
	graphene_point_t coords = {0};
	graphene_point_t _tmp6_ = {0};
	MetaCursorTracker* _tmp7_;
	graphene_point_t _tmp8_ = {0};
	graphene_point_t _tmp9_;
	gfloat _tmp10_;
	gfloat _tmp11_;
	graphene_point_t _tmp12_;
	gfloat _tmp13_;
	gfloat _tmp14_;
	ClutterPropertyTransition* _tmp15_;
	ClutterPropertyTransition* _tmp16_;
#line 71 "../src/Widgets/DwellClickTimer.vala"
	g_return_if_fail (device != NULL);
#line 72 "../src/Widgets/DwellClickTimer.vala"
	_tmp0_ = self->priv->_wm;
#line 72 "../src/Widgets/DwellClickTimer.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 72 "../src/Widgets/DwellClickTimer.vala"
	display = _tmp1_;
#line 73 "../src/Widgets/DwellClickTimer.vala"
	_tmp2_ = display;
#line 73 "../src/Widgets/DwellClickTimer.vala"
	_tmp3_ = display;
#line 73 "../src/Widgets/DwellClickTimer.vala"
	scale = meta_display_get_monitor_scale (_tmp2_, meta_display_get_current_monitor (_tmp3_));
#line 74 "../src/Widgets/DwellClickTimer.vala"
	gala_dwell_click_timer_update_cursor_size (self, scale);
#line 76 "../src/Widgets/DwellClickTimer.vala"
	_tmp4_ = display;
#line 76 "../src/Widgets/DwellClickTimer.vala"
	_tmp5_ = meta_cursor_tracker_get_for_display (_tmp4_);
#line 76 "../src/Widgets/DwellClickTimer.vala"
	tracker = _tmp5_;
#line 77 "../src/Widgets/DwellClickTimer.vala"
	coords = _tmp6_;
#line 78 "../src/Widgets/DwellClickTimer.vala"
	_tmp7_ = tracker;
#line 78 "../src/Widgets/DwellClickTimer.vala"
	meta_cursor_tracker_get_pointer (_tmp7_, &_tmp8_, NULL);
#line 78 "../src/Widgets/DwellClickTimer.vala"
	coords = _tmp8_;
#line 80 "../src/Widgets/DwellClickTimer.vala"
	_tmp9_ = coords;
#line 80 "../src/Widgets/DwellClickTimer.vala"
	_tmp10_ = clutter_actor_get_width ((ClutterActor*) self);
#line 80 "../src/Widgets/DwellClickTimer.vala"
	_tmp11_ = _tmp10_;
#line 80 "../src/Widgets/DwellClickTimer.vala"
	clutter_actor_set_x ((ClutterActor*) self, _tmp9_.x - (_tmp11_ / 2));
#line 81 "../src/Widgets/DwellClickTimer.vala"
	_tmp12_ = coords;
#line 81 "../src/Widgets/DwellClickTimer.vala"
	_tmp13_ = clutter_actor_get_width ((ClutterActor*) self);
#line 81 "../src/Widgets/DwellClickTimer.vala"
	_tmp14_ = _tmp13_;
#line 81 "../src/Widgets/DwellClickTimer.vala"
	clutter_actor_set_y ((ClutterActor*) self, _tmp12_.y - (_tmp14_ / 2));
#line 83 "../src/Widgets/DwellClickTimer.vala"
	_tmp15_ = self->priv->transition;
#line 83 "../src/Widgets/DwellClickTimer.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp15_, timeout);
#line 84 "../src/Widgets/DwellClickTimer.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 85 "../src/Widgets/DwellClickTimer.vala"
	_tmp16_ = self->priv->transition;
#line 85 "../src/Widgets/DwellClickTimer.vala"
	clutter_timeline_start ((ClutterTimeline*) _tmp16_);
#line 796 "DwellClickTimer.c"
}

static void
__gala_dwell_click_timer___lambda132__clutter_seat_ptr_a11y_timeout_started (ClutterSeat* _sender,
                                                                             ClutterInputDevice* device,
                                                                             ClutterPointerA11yTimeoutType timeout_type,
                                                                             guint delay,
                                                                             gpointer self)
{
#line 71 "../src/Widgets/DwellClickTimer.vala"
	_gala_dwell_click_timer___lambda132_ ((GalaDwellClickTimer*) self, device, timeout_type, delay);
#line 808 "DwellClickTimer.c"
}

static void
_gala_dwell_click_timer___lambda133_ (GalaDwellClickTimer* self,
                                      ClutterInputDevice* device,
                                      ClutterPointerA11yTimeoutType type,
                                      gboolean clicked)
{
	ClutterPropertyTransition* _tmp0_;
#line 88 "../src/Widgets/DwellClickTimer.vala"
	g_return_if_fail (device != NULL);
#line 89 "../src/Widgets/DwellClickTimer.vala"
	_tmp0_ = self->priv->transition;
#line 89 "../src/Widgets/DwellClickTimer.vala"
	clutter_timeline_stop ((ClutterTimeline*) _tmp0_);
#line 90 "../src/Widgets/DwellClickTimer.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 826 "DwellClickTimer.c"
}

static void
__gala_dwell_click_timer___lambda133__clutter_seat_ptr_a11y_timeout_stopped (ClutterSeat* _sender,
                                                                             ClutterInputDevice* device,
                                                                             ClutterPointerA11yTimeoutType timeout_type,
                                                                             gboolean clicked,
                                                                             gpointer self)
{
#line 88 "../src/Widgets/DwellClickTimer.vala"
	_gala_dwell_click_timer___lambda133_ ((GalaDwellClickTimer*) self, device, timeout_type, clicked);
#line 838 "DwellClickTimer.c"
}

static GObject *
gala_dwell_click_timer_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaDwellClickTimer * self;
	ClutterBackend* _tmp0_;
	CoglContext* _tmp1_;
	CoglPipeline* _tmp2_;
	ClutterPropertyTransition* _tmp3_;
	ClutterPropertyTransition* _tmp4_;
	ClutterPropertyTransition* _tmp5_;
	ClutterPropertyTransition* _tmp6_;
	GValue _tmp7_ = {0};
	ClutterPropertyTransition* _tmp8_;
	GValue _tmp9_ = {0};
	ClutterPropertyTransition* _tmp10_;
	GSettings* _tmp11_;
	ClutterSeat* seat = NULL;
	ClutterBackend* _tmp12_;
	ClutterSeat* _tmp13_;
	ClutterSeat* _tmp14_;
	ClutterSeat* _tmp15_;
	ClutterSeat* _tmp16_;
	ClutterSeat* _tmp17_;
#line 50 "../src/Widgets/DwellClickTimer.vala"
	parent_class = G_OBJECT_CLASS (gala_dwell_click_timer_parent_class);
#line 50 "../src/Widgets/DwellClickTimer.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 50 "../src/Widgets/DwellClickTimer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimer);
#line 51 "../src/Widgets/DwellClickTimer.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 52 "../src/Widgets/DwellClickTimer.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, FALSE);
#line 54 "../src/Widgets/DwellClickTimer.vala"
	_tmp0_ = clutter_get_default_backend ();
#line 54 "../src/Widgets/DwellClickTimer.vala"
	_tmp1_ = clutter_backend_get_cogl_context (_tmp0_);
#line 54 "../src/Widgets/DwellClickTimer.vala"
	_tmp2_ = cogl_pipeline_new (_tmp1_);
#line 54 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 54 "../src/Widgets/DwellClickTimer.vala"
	self->priv->pipeline = _tmp2_;
#line 56 "../src/Widgets/DwellClickTimer.vala"
	_tmp3_ = (ClutterPropertyTransition*) clutter_property_transition_new ("angle");
#line 56 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (self->priv->transition);
#line 56 "../src/Widgets/DwellClickTimer.vala"
	self->priv->transition = _tmp3_;
#line 57 "../src/Widgets/DwellClickTimer.vala"
	_tmp4_ = self->priv->transition;
#line 57 "../src/Widgets/DwellClickTimer.vala"
	clutter_timeline_set_progress_mode ((ClutterTimeline*) _tmp4_, CLUTTER_EASE_OUT_QUAD);
#line 58 "../src/Widgets/DwellClickTimer.vala"
	_tmp5_ = self->priv->transition;
#line 58 "../src/Widgets/DwellClickTimer.vala"
	clutter_transition_set_animatable ((ClutterTransition*) _tmp5_, (ClutterAnimatable*) self);
#line 59 "../src/Widgets/DwellClickTimer.vala"
	_tmp6_ = self->priv->transition;
#line 59 "../src/Widgets/DwellClickTimer.vala"
	g_value_init (&_tmp7_, G_TYPE_DOUBLE);
#line 59 "../src/Widgets/DwellClickTimer.vala"
	g_value_set_double (&_tmp7_, GALA_DWELL_CLICK_TIMER_START_ANGLE);
#line 59 "../src/Widgets/DwellClickTimer.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp6_, &_tmp7_);
#line 59 "../src/Widgets/DwellClickTimer.vala"
	G_IS_VALUE (&_tmp7_) ? (g_value_unset (&_tmp7_), NULL) : NULL;
#line 60 "../src/Widgets/DwellClickTimer.vala"
	_tmp8_ = self->priv->transition;
#line 60 "../src/Widgets/DwellClickTimer.vala"
	g_value_init (&_tmp9_, G_TYPE_DOUBLE);
#line 60 "../src/Widgets/DwellClickTimer.vala"
	g_value_set_double (&_tmp9_, GALA_DWELL_CLICK_TIMER_START_ANGLE + (2 * G_PI));
#line 60 "../src/Widgets/DwellClickTimer.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp8_, &_tmp9_);
#line 60 "../src/Widgets/DwellClickTimer.vala"
	G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
#line 62 "../src/Widgets/DwellClickTimer.vala"
	_tmp10_ = self->priv->transition;
#line 62 "../src/Widgets/DwellClickTimer.vala"
	g_signal_connect_object ((ClutterTimeline*) _tmp10_, "new-frame", (GCallback) __gala_dwell_click_timer___lambda131__clutter_timeline_new_frame, self, 0);
#line 66 "../src/Widgets/DwellClickTimer.vala"
	_tmp11_ = g_settings_new ("org.gnome.desktop.interface");
#line 66 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (self->priv->interface_settings);
#line 66 "../src/Widgets/DwellClickTimer.vala"
	self->priv->interface_settings = _tmp11_;
#line 68 "../src/Widgets/DwellClickTimer.vala"
	_tmp12_ = clutter_get_default_backend ();
#line 68 "../src/Widgets/DwellClickTimer.vala"
	_tmp13_ = clutter_backend_get_default_seat (_tmp12_);
#line 68 "../src/Widgets/DwellClickTimer.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 68 "../src/Widgets/DwellClickTimer.vala"
	seat = _tmp14_;
#line 69 "../src/Widgets/DwellClickTimer.vala"
	_tmp15_ = seat;
#line 69 "../src/Widgets/DwellClickTimer.vala"
	clutter_seat_set_pointer_a11y_dwell_click_type (_tmp15_, CLUTTER_A11Y_DWELL_CLICK_TYPE_PRIMARY);
#line 71 "../src/Widgets/DwellClickTimer.vala"
	_tmp16_ = seat;
#line 71 "../src/Widgets/DwellClickTimer.vala"
	g_signal_connect_object (_tmp16_, "ptr-a11y-timeout-started", (GCallback) __gala_dwell_click_timer___lambda132__clutter_seat_ptr_a11y_timeout_started, self, 0);
#line 88 "../src/Widgets/DwellClickTimer.vala"
	_tmp17_ = seat;
#line 88 "../src/Widgets/DwellClickTimer.vala"
	g_signal_connect_object (_tmp17_, "ptr-a11y-timeout-stopped", (GCallback) __gala_dwell_click_timer___lambda133__clutter_seat_ptr_a11y_timeout_stopped, self, 0);
#line 50 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (seat);
#line 50 "../src/Widgets/DwellClickTimer.vala"
	return obj;
#line 956 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_class_init (GalaDwellClickTimerClass * klass,
                                   gpointer klass_data)
{
#line 19 "../src/Widgets/DwellClickTimer.vala"
	gala_dwell_click_timer_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/Widgets/DwellClickTimer.vala"
	g_type_class_adjust_private_offset (klass, &GalaDwellClickTimer_private_offset);
#line 19 "../src/Widgets/DwellClickTimer.vala"
	((ClutterActorClass *) klass)->paint = (void (*) (ClutterActor*, ClutterPaintContext*)) gala_dwell_click_timer_real_paint;
#line 19 "../src/Widgets/DwellClickTimer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_dwell_click_timer_get_property;
#line 19 "../src/Widgets/DwellClickTimer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_dwell_click_timer_set_property;
#line 19 "../src/Widgets/DwellClickTimer.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_dwell_click_timer_constructor;
#line 19 "../src/Widgets/DwellClickTimer.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_dwell_click_timer_finalize;
#line 19 "../src/Widgets/DwellClickTimer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DWELL_CLICK_TIMER_WM_PROPERTY, gala_dwell_click_timer_properties[GALA_DWELL_CLICK_TIMER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../src/Widgets/DwellClickTimer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DWELL_CLICK_TIMER_ANGLE_PROPERTY, gala_dwell_click_timer_properties[GALA_DWELL_CLICK_TIMER_ANGLE_PROPERTY] = g_param_spec_double ("angle", "angle", "angle", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 981 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_clutter_animatable_interface_init (ClutterAnimatableInterface * iface,
                                                          gpointer iface_data)
{
#line 19 "../src/Widgets/DwellClickTimer.vala"
	gala_dwell_click_timer_clutter_animatable_parent_iface = g_type_interface_peek_parent (iface);
#line 19 "../src/Widgets/DwellClickTimer.vala"
	iface->interpolate_value = (gboolean (*) (ClutterAnimatable*, const gchar*, ClutterInterval*, gdouble, GValue*)) gala_dwell_click_timer_real_interpolate_value;
#line 992 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_instance_init (GalaDwellClickTimer * self,
                                      gpointer klass)
{
#line 19 "../src/Widgets/DwellClickTimer.vala"
	self->priv = gala_dwell_click_timer_get_instance_private (self);
#line 32 "../src/Widgets/DwellClickTimer.vala"
	self->priv->scaling_factor = 1.0f;
#line 33 "../src/Widgets/DwellClickTimer.vala"
	self->priv->cursor_size = 24;
#line 1005 "DwellClickTimer.c"
}

static void
gala_dwell_click_timer_finalize (GObject * obj)
{
	GalaDwellClickTimer * self;
#line 19 "../src/Widgets/DwellClickTimer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimer);
#line 35 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 36 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (self->priv->transition);
#line 37 "../src/Widgets/DwellClickTimer.vala"
	_cairo_pattern_destroy0 (self->priv->stroke_color);
#line 38 "../src/Widgets/DwellClickTimer.vala"
	_cairo_pattern_destroy0 (self->priv->fill_color);
#line 39 "../src/Widgets/DwellClickTimer.vala"
	_g_object_unref0 (self->priv->interface_settings);
#line 40 "../src/Widgets/DwellClickTimer.vala"
	_cairo_surface_destroy0 (self->priv->surface);
#line 19 "../src/Widgets/DwellClickTimer.vala"
	G_OBJECT_CLASS (gala_dwell_click_timer_parent_class)->finalize (obj);
#line 1028 "DwellClickTimer.c"
}

static GType
gala_dwell_click_timer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaDwellClickTimerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_dwell_click_timer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDwellClickTimer), 0, (GInstanceInitFunc) gala_dwell_click_timer_instance_init, NULL };
	static const GInterfaceInfo clutter_animatable_info = { (GInterfaceInitFunc) gala_dwell_click_timer_clutter_animatable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_dwell_click_timer_type_id;
	gala_dwell_click_timer_type_id = g_type_register_static (clutter_actor_get_type (), "GalaDwellClickTimer", &g_define_type_info, 0);
	g_type_add_interface_static (gala_dwell_click_timer_type_id, clutter_animatable_get_type (), &clutter_animatable_info);
	GalaDwellClickTimer_private_offset = g_type_add_instance_private (gala_dwell_click_timer_type_id, sizeof (GalaDwellClickTimerPrivate));
	return gala_dwell_click_timer_type_id;
}

GType
gala_dwell_click_timer_get_type (void)
{
	static volatile gsize gala_dwell_click_timer_type_id__once = 0;
	if (g_once_init_enter (&gala_dwell_click_timer_type_id__once)) {
		GType gala_dwell_click_timer_type_id;
		gala_dwell_click_timer_type_id = gala_dwell_click_timer_get_type_once ();
		g_once_init_leave (&gala_dwell_click_timer_type_id__once, gala_dwell_click_timer_type_id);
	}
	return gala_dwell_click_timer_type_id__once;
}

static void
_vala_gala_dwell_click_timer_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GalaDwellClickTimer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimer);
#line 19 "../src/Widgets/DwellClickTimer.vala"
	switch (property_id) {
#line 19 "../src/Widgets/DwellClickTimer.vala"
		case GALA_DWELL_CLICK_TIMER_WM_PROPERTY:
#line 19 "../src/Widgets/DwellClickTimer.vala"
		g_value_set_object (value, gala_dwell_click_timer_get_wm (self));
#line 19 "../src/Widgets/DwellClickTimer.vala"
		break;
#line 19 "../src/Widgets/DwellClickTimer.vala"
		case GALA_DWELL_CLICK_TIMER_ANGLE_PROPERTY:
#line 19 "../src/Widgets/DwellClickTimer.vala"
		g_value_set_double (value, gala_dwell_click_timer_get_angle (self));
#line 19 "../src/Widgets/DwellClickTimer.vala"
		break;
#line 1077 "DwellClickTimer.c"
		default:
#line 19 "../src/Widgets/DwellClickTimer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/Widgets/DwellClickTimer.vala"
		break;
#line 1083 "DwellClickTimer.c"
	}
}

static void
_vala_gala_dwell_click_timer_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GalaDwellClickTimer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimer);
#line 19 "../src/Widgets/DwellClickTimer.vala"
	switch (property_id) {
#line 19 "../src/Widgets/DwellClickTimer.vala"
		case GALA_DWELL_CLICK_TIMER_WM_PROPERTY:
#line 19 "../src/Widgets/DwellClickTimer.vala"
		gala_dwell_click_timer_set_wm (self, g_value_get_object (value));
#line 19 "../src/Widgets/DwellClickTimer.vala"
		break;
#line 19 "../src/Widgets/DwellClickTimer.vala"
		case GALA_DWELL_CLICK_TIMER_ANGLE_PROPERTY:
#line 19 "../src/Widgets/DwellClickTimer.vala"
		gala_dwell_click_timer_set_angle (self, g_value_get_double (value));
#line 19 "../src/Widgets/DwellClickTimer.vala"
		break;
#line 1109 "DwellClickTimer.c"
		default:
#line 19 "../src/Widgets/DwellClickTimer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/Widgets/DwellClickTimer.vala"
		break;
#line 1115 "DwellClickTimer.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 21 "../src/PluginManager.vala"
	if (mem && byte_size != 0) {
#line 21 "../src/PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 21 "../src/PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 1130 "DwellClickTimer.c"
	} else {
#line 21 "../src/PluginManager.vala"
		new_mem = NULL;
#line 1134 "DwellClickTimer.c"
	}
#line 21 "../src/PluginManager.vala"
	return new_mem;
#line 1138 "DwellClickTimer.c"
}

