/* WindowSwitcher.c generated by valac 0.56.14, the Vala compiler
 * generated from WindowSwitcher.vala, do not modify */

/*
 * Copyright 2021 Aral Balkan <mail@ar.al>
 * Copyright 2020 Mark Story <mark@mark-story.com>
 * Copyright 2017 Popye <sailor3101@gmail.com>
 * Copyright 2014 Tom Beckmann
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <clutter/clutter.h>
#include <glib-object.h>
#include "gala.h"
#include <glib.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>
#include <pango/pango.h>
#include <meta/display.h>
#include <meta/window.h>
#include <meta/keybindings.h>
#include <meta/workspace.h>
#include <meta/meta-workspace-manager.h>
#include <meta/meta-plugin.h>
#include <mtk/mtk.h>
#include <meta/prefs.h>
#include <meta/meta-cursor-tracker.h>
#include <meta/meta-monitor-manager.h>
#include <meta/meta-context.h>
#include <meta/meta-backend.h>

#define GALA_WINDOW_SWITCHER_ICON_SIZE 64
#define GALA_WINDOW_SWITCHER_WRAPPER_PADDING 12
#define GALA_WINDOW_SWITCHER_CAPTION_FONT_NAME "Inter"
#define GALA_WINDOW_SWITCHER_MIN_OFFSET 64
#define GALA_WINDOW_SWITCHER_ANIMATION_DURATION 200
#define GALA_WINDOW_SWITCHER_GESTURE_RANGE_LIMIT 10
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WINDOW_SWITCHER (gala_window_switcher_get_type ())
#define GALA_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher))
#define GALA_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))
#define GALA_IS_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_IS_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_WINDOW_SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))

typedef struct _GalaWindowSwitcher GalaWindowSwitcher;
typedef struct _GalaWindowSwitcherClass GalaWindowSwitcherClass;
typedef struct _GalaWindowSwitcherPrivate GalaWindowSwitcherPrivate;

#define GALA_TYPE_GESTURE_TRACKER (gala_gesture_tracker_get_type ())
#define GALA_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTracker))
#define GALA_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))
#define GALA_IS_GESTURE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TRACKER))
#define GALA_IS_GESTURE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_TRACKER))
#define GALA_GESTURE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_TRACKER, GalaGestureTrackerClass))

typedef struct _GalaGestureTracker GalaGestureTracker;
typedef struct _GalaGestureTrackerClass GalaGestureTrackerClass;

#define GALA_TYPE_WINDOW_SWITCHER_ICON (gala_window_switcher_icon_get_type ())
#define GALA_WINDOW_SWITCHER_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIcon))
#define GALA_WINDOW_SWITCHER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIconClass))
#define GALA_IS_WINDOW_SWITCHER_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_SWITCHER_ICON))
#define GALA_IS_WINDOW_SWITCHER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_SWITCHER_ICON))
#define GALA_WINDOW_SWITCHER_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIconClass))

typedef struct _GalaWindowSwitcherIcon GalaWindowSwitcherIcon;
typedef struct _GalaWindowSwitcherIconClass GalaWindowSwitcherIconClass;
enum  {
	GALA_WINDOW_SWITCHER_0_PROPERTY,
	GALA_WINDOW_SWITCHER_WM_PROPERTY,
	GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY,
	GALA_WINDOW_SWITCHER_OPENED_PROPERTY,
	GALA_WINDOW_SWITCHER_NUM_PROPERTIES
};
static GParamSpec* gala_window_switcher_properties[GALA_WINDOW_SWITCHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gtk_widget_path_unref0(var) ((var == NULL) ? NULL : (var = (gtk_widget_path_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_ClutterColor_free0(var) ((var == NULL) ? NULL : (var = (_vala_ClutterColor_free (var), NULL)))
typedef enum  {
	GALA_GESTURE_DIRECTION_UNKNOWN = 0,
	GALA_GESTURE_DIRECTION_UP = 1,
	GALA_GESTURE_DIRECTION_DOWN = 2,
	GALA_GESTURE_DIRECTION_LEFT = 3,
	GALA_GESTURE_DIRECTION_RIGHT = 4,
	GALA_GESTURE_DIRECTION_IN = 5,
	GALA_GESTURE_DIRECTION_OUT = 6
} GalaGestureDirection;

#define GALA_TYPE_GESTURE_DIRECTION (gala_gesture_direction_get_type ())
typedef struct _Block72Data Block72Data;
typedef void (*GalaGestureTrackerOnUpdate) (gdouble percentage, gpointer user_data);
typedef void (*GalaGestureTrackerOnEnd) (gdouble percentage, gboolean cancel_action, gint calculated_duration, gpointer user_data);
typedef void (*GalaGestureTrackerOnBegin) (gdouble percentage, gpointer user_data);

#define GALA_TYPE_WINDOW_TRACKER (gala_window_tracker_get_type ())
#define GALA_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTracker))
#define GALA_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))
#define GALA_IS_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_TRACKER))
#define GALA_IS_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_TRACKER))
#define GALA_WINDOW_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))

typedef struct _GalaWindowTracker GalaWindowTracker;
typedef struct _GalaWindowTrackerClass GalaWindowTrackerClass;

#define GALA_TYPE_WINDOW_MANAGER_GALA (gala_window_manager_gala_get_type ())
#define GALA_WINDOW_MANAGER_GALA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala))
#define GALA_WINDOW_MANAGER_GALA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGalaClass))
#define GALA_IS_WINDOW_MANAGER_GALA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_MANAGER_GALA))
#define GALA_IS_WINDOW_MANAGER_GALA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_MANAGER_GALA))
#define GALA_WINDOW_MANAGER_GALA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGalaClass))

typedef struct _GalaWindowManagerGala GalaWindowManagerGala;
typedef struct _GalaWindowManagerGalaClass GalaWindowManagerGalaClass;
typedef struct _Block73Data Block73Data;

struct _GalaWindowSwitcher {
	ClutterActor parent_instance;
	GalaWindowSwitcherPrivate * priv;
};

struct _GalaWindowSwitcherClass {
	ClutterActorClass parent_class;
};

struct _GalaWindowSwitcherPrivate {
	GalaWindowManager* _wm;
	GalaGestureTracker* _gesture_tracker;
	gboolean _opened;
	gboolean handling_gesture;
	gint modifier_mask;
	GalaModalProxy* modal_proxy;
	GraniteSettings* granite_settings;
	ClutterCanvas* canvas;
	ClutterActor* container;
	ClutterText* caption;
	GtkWidgetPath* widget_path;
	GtkStyleContext* style_context;
	GtkCssProvider* dark_style_provider;
	GalaWindowSwitcherIcon* _current_icon;
	gfloat scaling_factor;
};

struct _Block72Data {
	int _ref_count_;
	GalaWindowSwitcher* self;
	gint last_window_index;
	GalaGestureDirection direction;
};

struct _Block73Data {
	int _ref_count_;
	GalaWindowSwitcher* self;
	MetaDisplay* display;
	GalaShadowEffect* effect;
};

static gint GalaWindowSwitcher_private_offset;
static gpointer gala_window_switcher_parent_class = NULL;

VALA_EXTERN GType gala_window_switcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowSwitcher, g_object_unref)
VALA_EXTERN GType gala_gesture_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTracker, g_object_unref)
VALA_EXTERN GType gala_window_switcher_icon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowSwitcherIcon, g_object_unref)
VALA_EXTERN GalaWindowSwitcher* gala_window_switcher_new (GalaWindowManager* wm,
                                              GalaGestureTracker* gesture_tracker);
VALA_EXTERN GalaWindowSwitcher* gala_window_switcher_construct (GType object_type,
                                                    GalaWindowManager* wm,
                                                    GalaGestureTracker* gesture_tracker);
static gboolean gala_window_switcher_draw (GalaWindowSwitcher* self,
                                    cairo_t* ctx,
                                    gint width,
                                    gint height);
static void gala_window_switcher_create_gtk_objects (GalaWindowSwitcher* self);
static void gala_window_switcher_create_components (GalaWindowSwitcher* self);
VALA_EXTERN gint gala_internal_utils_scale_to_int (gint value,
                                       gfloat scale_factor);
static gboolean gala_window_switcher_container_mouse_release (GalaWindowSwitcher* self,
                                                       ClutterEvent* event);
static gboolean _gala_window_switcher_container_mouse_release_clutter_actor_button_release_event (ClutterActor* _sender,
                                                                                           ClutterEvent* event,
                                                                                           gpointer self);
static gboolean gala_window_switcher_container_motion_event (GalaWindowSwitcher* self,
                                                      ClutterEvent* event);
static gboolean _gala_window_switcher_container_motion_event_clutter_actor_motion_event (ClutterActor* _sender,
                                                                                  ClutterEvent* event,
                                                                                  gpointer self);
static void _vala_ClutterColor_free (ClutterColor* self);
VALA_EXTERN void gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                                 MetaWindow* window,
                                                 ClutterKeyEvent* event,
                                                 MetaKeyBinding* binding,
                                                 GalaWindowSwitcher* self);
VALA_EXTERN gboolean gala_window_switcher_get_opened (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_collect_current_windows (GalaWindowSwitcher* self,
                                                       MetaDisplay* display,
                                                       MetaWorkspace* workspace);
static gboolean gala_window_switcher_collect_all_windows (GalaWindowSwitcher* self,
                                                   MetaDisplay* display,
                                                   MetaWorkspace* workspace);
static void gala_window_switcher_open_switcher (GalaWindowSwitcher* self);
static void gala_window_switcher_next_window (GalaWindowSwitcher* self,
                                       gboolean backward);
VALA_EXTERN GType gala_gesture_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void gala_window_switcher_handle_gesture (GalaWindowSwitcher* self,
                                          GalaGestureDirection direction);
static Block72Data* block72_data_ref (Block72Data* _data72_);
static void block72_data_unref (void * _userdata_);
VALA_EXTERN GalaWindowManager* gala_window_switcher_get_wm (GalaWindowSwitcher* self);
static void __lambda82_ (Block72Data* _data72_,
                  gdouble percentage);
VALA_EXTERN gfloat gala_gesture_tracker_animation_value (gfloat initial_value,
                                             gfloat target_value,
                                             gdouble percentage,
                                             gboolean rounded);
static void ___lambda82__gala_gesture_tracker_on_update (gdouble percentage,
                                                  gpointer self);
static void __lambda83_ (GalaWindowSwitcher* self,
                  gdouble percentage,
                  gboolean cancel_action,
                  gint calculated_duration);
static void gala_window_switcher_close_switcher (GalaWindowSwitcher* self,
                                          guint32 time,
                                          gboolean cancel);
static void ___lambda83__gala_gesture_tracker_on_end (gdouble percentage,
                                               gboolean cancel_action,
                                               gint calculated_duration,
                                               gpointer self);
VALA_EXTERN GalaGestureTracker* gala_window_switcher_get_gesture_tracker (GalaWindowSwitcher* self);
VALA_EXTERN void gala_gesture_tracker_connect_handlers (GalaGestureTracker* self,
                                            GalaGestureTrackerOnBegin on_begin_handler,
                                            gpointer on_begin_handler_target,
                                            GDestroyNotify on_begin_handler_target_destroy_notify,
                                            GalaGestureTrackerOnUpdate on_update_handler,
                                            gpointer on_update_handler_target,
                                            GDestroyNotify on_update_handler_target_destroy_notify,
                                            GalaGestureTrackerOnEnd on_end_handler,
                                            gpointer on_end_handler_target,
                                            GDestroyNotify on_end_handler_target_destroy_notify);
static void gala_window_switcher_set_current_icon (GalaWindowSwitcher* self,
                                            GalaWindowSwitcherIcon* value);
VALA_EXTERN GalaWindowSwitcherIcon* gala_window_switcher_icon_new (MetaWindow* window,
                                                       gint icon_size,
                                                       gfloat scale_factor);
VALA_EXTERN GalaWindowSwitcherIcon* gala_window_switcher_icon_construct (GType object_type,
                                                             MetaWindow* window,
                                                             gint icon_size,
                                                             gfloat scale_factor);
VALA_EXTERN GType gala_window_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowTracker, g_object_unref)
VALA_EXTERN GType gala_window_manager_gala_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowManagerGala, g_object_unref)
VALA_EXTERN GalaWindowTracker* gala_window_manager_gala_get_window_tracker (GalaWindowManagerGala* self);
VALA_EXTERN GalaApp* gala_window_tracker_get_app_for_window (GalaWindowTracker* self,
                                                 MetaWindow* window);
static void gala_window_switcher_update_caption_text (GalaWindowSwitcher* self);
static void gala_window_switcher_toggle_display (GalaWindowSwitcher* self,
                                          gboolean show);
static void gala_window_switcher_set_opened (GalaWindowSwitcher* self,
                                      gboolean value);
static void gala_window_switcher_push_modal (GalaWindowSwitcher* self);
static gboolean __lambda81_ (GalaWindowSwitcher* self,
                      MetaKeyBinding* binding);
static gboolean ___lambda81__gala_keybinding_filter (MetaKeyBinding* binding,
                                              gpointer self);
static GalaWindowSwitcherIcon* gala_window_switcher_get_current_icon (GalaWindowSwitcher* self);
VALA_EXTERN MetaWindow* gala_window_switcher_icon_get_window (GalaWindowSwitcherIcon* self);
static void gala_window_switcher_real_key_focus_out (ClutterActor* base);
static gboolean gala_window_switcher_real_key_release_event (ClutterActor* base,
                                                      ClutterEvent* event);
static inline ClutterModifierType gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_real_key_press_event (ClutterActor* base,
                                                    ClutterEvent* event);
static void gala_window_switcher_set_wm (GalaWindowSwitcher* self,
                                  GalaWindowManager* value);
static void gala_window_switcher_set_gesture_tracker (GalaWindowSwitcher* self,
                                               GalaGestureTracker* value);
VALA_EXTERN void gala_window_switcher_icon_set_selected (GalaWindowSwitcherIcon* self,
                                             gboolean value);
static GObject * gala_window_switcher_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static Block73Data* block73_data_ref (Block73Data* _data73_);
static void block73_data_unref (void * _userdata_);
static void _gala_window_switcher___lambda84_ (GalaWindowSwitcher* self);
static void __gala_window_switcher___lambda84__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _gala_window_switcher___lambda85_ (GalaWindowSwitcher* self);
static void __gala_window_switcher___lambda85__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _gala_window_switcher___lambda86_ (Block73Data* _data73_);
static void __gala_window_switcher___lambda86__meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                               gpointer self);
static gboolean _gala_window_switcher_draw_clutter_canvas_draw (ClutterCanvas* _sender,
                                                         cairo_t* cr,
                                                         gint width,
                                                         gint height,
                                                         gpointer self);
static void gala_window_switcher_finalize (GObject * obj);
static GType gala_window_switcher_get_type_once (void);
static void _vala_gala_window_switcher_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_window_switcher_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gala_window_switcher_get_instance_private (GalaWindowSwitcher* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowSwitcher_private_offset);
}

GalaWindowSwitcher*
gala_window_switcher_construct (GType object_type,
                                GalaWindowManager* wm,
                                GalaGestureTracker* gesture_tracker)
{
	GalaWindowSwitcher * self = NULL;
#line 57 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 57 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (gesture_tracker != NULL, NULL);
#line 58 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) g_object_new (object_type, "wm", wm, "gesture-tracker", gesture_tracker, NULL);
#line 57 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return self;
#line 359 "WindowSwitcher.c"
}

GalaWindowSwitcher*
gala_window_switcher_new (GalaWindowManager* wm,
                          GalaGestureTracker* gesture_tracker)
{
#line 57 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return gala_window_switcher_construct (GALA_TYPE_WINDOW_SWITCHER, wm, gesture_tracker);
#line 368 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_draw (GalaWindowSwitcher* self,
                           cairo_t* ctx,
                           gint width,
                           gint height)
{
	GtkStyleContext* _tmp0_;
	GraniteSettings* _tmp1_;
	GraniteSettingsColorScheme _tmp2_;
	GraniteSettingsColorScheme _tmp3_;
	GtkStyleContext* _tmp15_;
	GtkStyleContext* _tmp16_;
	gboolean result;
#line 112 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 112 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 113 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->style_context;
#line 113 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_ == NULL) {
#line 114 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_create_gtk_objects (self);
#line 394 "WindowSwitcher.c"
	}
#line 117 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_save (ctx);
#line 118 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_CLEAR);
#line 119 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_paint (ctx);
#line 120 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_clip (ctx);
#line 121 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_reset_clip (ctx);
#line 123 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->granite_settings;
#line 123 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = granite_settings_get_prefers_color_scheme (_tmp1_);
#line 123 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = _tmp2_;
#line 123 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK) {
#line 414 "WindowSwitcher.c"
		GtkSettings* gtksettings = NULL;
		GtkSettings* _tmp4_;
		GtkSettings* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GtkCssProvider* _tmp9_;
		GtkStyleContext* _tmp10_;
		GtkCssProvider* _tmp11_;
#line 124 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = gtk_settings_get_default ();
#line 124 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gtksettings = _tmp4_;
#line 125 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = gtksettings;
#line 125 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_object_get (_tmp5_, "gtk-theme-name", &_tmp6_, NULL);
#line 125 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp7_ = _tmp6_;
#line 125 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = _tmp7_;
#line 125 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp9_ = gtk_css_provider_get_named (_tmp8_, "dark");
#line 125 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->dark_style_provider = _tmp9_;
#line 125 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_free0 (_tmp8_);
#line 126 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = self->priv->style_context;
#line 126 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp11_ = self->priv->dark_style_provider;
#line 126 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gtk_style_context_add_provider (_tmp10_, (GtkStyleProvider*) _tmp11_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 448 "WindowSwitcher.c"
	} else {
		GtkCssProvider* _tmp12_;
#line 127 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp12_ = self->priv->dark_style_provider;
#line 127 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (_tmp12_ != NULL) {
#line 455 "WindowSwitcher.c"
			GtkStyleContext* _tmp13_;
			GtkCssProvider* _tmp14_;
#line 128 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp13_ = self->priv->style_context;
#line 128 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp14_ = self->priv->dark_style_provider;
#line 128 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			gtk_style_context_remove_provider (_tmp13_, (GtkStyleProvider*) _tmp14_);
#line 129 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			self->priv->dark_style_provider = NULL;
#line 466 "WindowSwitcher.c"
		}
	}
#line 132 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_OVER);
#line 133 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp15_ = self->priv->style_context;
#line 133 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gtk_render_background (_tmp15_, ctx, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height);
#line 134 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp16_ = self->priv->style_context;
#line 134 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gtk_render_frame (_tmp16_, ctx, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height);
#line 135 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cairo_restore (ctx);
#line 137 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 137 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 485 "WindowSwitcher.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return self ? g_object_ref (self) : NULL;
#line 493 "WindowSwitcher.c"
}

static gboolean
_gala_window_switcher_container_mouse_release_clutter_actor_button_release_event (ClutterActor* _sender,
                                                                                  ClutterEvent* event,
                                                                                  gpointer self)
{
	gboolean result;
	result = gala_window_switcher_container_mouse_release ((GalaWindowSwitcher*) self, event);
#line 157 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 505 "WindowSwitcher.c"
}

static gboolean
_gala_window_switcher_container_motion_event_clutter_actor_motion_event (ClutterActor* _sender,
                                                                         ClutterEvent* event,
                                                                         gpointer self)
{
	gboolean result;
	result = gala_window_switcher_container_motion_event ((GalaWindowSwitcher*) self, event);
#line 158 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 517 "WindowSwitcher.c"
}

static ClutterColor*
_vala_clutter_color_from_string (const gchar* str)
{
	ClutterColor* color = NULL;
	ClutterColor* _tmp0_;
	ClutterColor* result;
#line 7813 "mutter-clutter-14.vapi"
	g_return_val_if_fail (str != NULL, NULL);
#line 7814 "mutter-clutter-14.vapi"
	_tmp0_ = clutter_color_alloc ();
#line 7814 "mutter-clutter-14.vapi"
	color = _tmp0_;
#line 7815 "mutter-clutter-14.vapi"
	clutter_color_from_string (color, str);
#line 7816 "mutter-clutter-14.vapi"
	result = color;
#line 7816 "mutter-clutter-14.vapi"
	return result;
#line 538 "WindowSwitcher.c"
}

static void
_vala_ClutterColor_free (ClutterColor* self)
{
#line 166 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_boxed_free (clutter_color_get_type (), self);
#line 546 "WindowSwitcher.c"
}

static void
gala_window_switcher_create_components (GalaWindowSwitcher* self)
{
	ClutterActor* _tmp0_;
	gint margin = 0;
	ClutterFlowLayout* layout = NULL;
	ClutterFlowLayout* _tmp1_;
	ClutterFlowLayout* _tmp2_;
	ClutterLayoutManager* _tmp3_;
	ClutterActor* _tmp4_ = NULL;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	gchar* caption_color = NULL;
	gchar* _tmp7_;
	GraniteSettings* _tmp8_;
	GraniteSettingsColorScheme _tmp9_;
	GraniteSettingsColorScheme _tmp10_;
	const gchar* _tmp12_;
	ClutterColor* _tmp13_;
	ClutterColor* _tmp14_;
	ClutterColor _tmp15_;
	ClutterText* _tmp16_;
	ClutterText* _tmp17_;
	ClutterText* _tmp18_;
	ClutterText* _tmp19_;
	ClutterActor* _tmp20_;
	ClutterText* _tmp21_;
#line 140 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->container;
#line 142 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_ != NULL) {
#line 143 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		clutter_actor_destroy_all_children ((ClutterActor*) self);
#line 584 "WindowSwitcher.c"
	}
#line 146 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	margin = gala_internal_utils_scale_to_int (GALA_WINDOW_SWITCHER_WRAPPER_PADDING, self->priv->scaling_factor);
#line 147 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = (ClutterFlowLayout*) clutter_flow_layout_new (CLUTTER_FLOW_HORIZONTAL);
#line 147 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp1_);
#line 147 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	layout = _tmp1_;
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = layout;
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = _g_object_ref0 ((ClutterLayoutManager*) _tmp2_);
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = clutter_actor_new ();
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_reactive (_tmp4_, TRUE);
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_layout_manager (_tmp4_, _tmp3_);
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (_tmp3_);
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_left (_tmp4_, (gfloat) margin);
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_top (_tmp4_, (gfloat) margin);
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_right (_tmp4_, (gfloat) margin);
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_margin_bottom (_tmp4_, (gfloat) margin);
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp4_);
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->container);
#line 148 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->container = _tmp4_;
#line 157 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->container;
#line 157 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object (_tmp5_, "button-release-event", (GCallback) _gala_window_switcher_container_mouse_release_clutter_actor_button_release_event, self, 0);
#line 158 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = self->priv->container;
#line 158 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object (_tmp6_, "motion-event", (GCallback) _gala_window_switcher_container_motion_event_clutter_actor_motion_event, self, 0);
#line 160 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = g_strdup ("#2e2e31");
#line 160 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	caption_color = _tmp7_;
#line 162 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = self->priv->granite_settings;
#line 162 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = granite_settings_get_prefers_color_scheme (_tmp8_);
#line 162 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = _tmp9_;
#line 162 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp10_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK) {
#line 640 "WindowSwitcher.c"
		gchar* _tmp11_;
#line 163 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp11_ = g_strdup ("#fafafa");
#line 163 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_free0 (caption_color);
#line 163 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		caption_color = _tmp11_;
#line 648 "WindowSwitcher.c"
	}
#line 166 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = caption_color;
#line 166 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = _vala_clutter_color_from_string (_tmp12_);
#line 166 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = _tmp13_;
#line 166 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp15_ = *_tmp14_;
#line 166 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp16_ = (ClutterText*) clutter_text_new_full (GALA_WINDOW_SWITCHER_CAPTION_FONT_NAME, "", &_tmp15_);
#line 166 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp16_);
#line 166 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->caption);
#line 166 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->caption = _tmp16_;
#line 166 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	__vala_ClutterColor_free0 (_tmp14_);
#line 167 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp17_ = self->priv->caption;
#line 167 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_pivot_point ((ClutterActor*) _tmp17_, 0.5f, 0.5f);
#line 168 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp18_ = self->priv->caption;
#line 168 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_ellipsize (_tmp18_, PANGO_ELLIPSIZE_END);
#line 169 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp19_ = self->priv->caption;
#line 169 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_line_alignment (_tmp19_, PANGO_ALIGN_CENTER);
#line 171 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp20_ = self->priv->container;
#line 171 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp20_);
#line 172 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp21_ = self->priv->caption;
#line 172 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp21_);
#line 140 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (caption_color);
#line 140 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (layout);
#line 692 "WindowSwitcher.c"
}

static void
gala_window_switcher_create_gtk_objects (GalaWindowSwitcher* self)
{
	GtkWidgetPath* _tmp0_;
	GtkWidgetPath* _tmp1_;
	GtkWidgetPath* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkWidgetPath* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkStyleContext* _tmp9_;
#line 175 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = gtk_widget_path_new ();
#line 176 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_gtk_widget_path_unref0 (self->priv->widget_path);
#line 176 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->widget_path = _tmp0_;
#line 177 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->widget_path;
#line 177 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gtk_widget_path_append_type (_tmp1_, gtk_window_get_type ());
#line 178 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->widget_path;
#line 178 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gtk_widget_path_iter_set_object_name (_tmp2_, -1, "window");
#line 180 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = gtk_style_context_new ();
#line 180 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->style_context);
#line 180 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->style_context = _tmp3_;
#line 181 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->style_context;
#line 181 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gtk_style_context_set_scale (_tmp4_, (gint) round ((gdouble) self->priv->scaling_factor));
#line 182 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->style_context;
#line 182 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = self->priv->widget_path;
#line 182 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gtk_style_context_set_path (_tmp5_, _tmp6_);
#line 183 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = self->priv->style_context;
#line 183 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gtk_style_context_add_class (_tmp7_, "background");
#line 184 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = self->priv->style_context;
#line 184 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gtk_style_context_add_class (_tmp8_, "csd");
#line 185 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = self->priv->style_context;
#line 185 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gtk_style_context_add_class (_tmp9_, "unified");
#line 752 "WindowSwitcher.c"
}

void
gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                            MetaWindow* window,
                                            ClutterKeyEvent* event,
                                            MetaKeyBinding* binding,
                                            GalaWindowSwitcher* self)
{
	MetaWorkspace* workspace = NULL;
	MetaWorkspaceManager* _tmp0_;
	MetaWorkspace* _tmp1_;
	MetaWorkspace* _tmp2_;
	guint mask = 0U;
	gboolean _tmp3_;
	gchar* binding_name = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean backward = FALSE;
	const gchar* _tmp9_;
#line 189 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (display != NULL);
#line 189 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (event != NULL);
#line 189 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (binding != NULL);
#line 193 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (self->priv->handling_gesture) {
#line 194 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 785 "WindowSwitcher.c"
	}
#line 197 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = meta_display_get_workspace_manager (display);
#line 197 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_workspace_manager_get_active_workspace (_tmp0_);
#line 197 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 197 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	workspace = _tmp2_;
#line 200 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	mask = meta_key_binding_get_mask (binding);
#line 201 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (mask == ((guint) 0)) {
#line 202 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->modifier_mask = 0;
#line 801 "WindowSwitcher.c"
	} else {
#line 204 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->modifier_mask = 1;
#line 205 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		while (TRUE) {
#line 205 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!(mask > ((guint) 1))) {
#line 205 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				break;
#line 811 "WindowSwitcher.c"
			}
#line 206 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			mask >>= (guint) 1;
#line 207 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			self->priv->modifier_mask = self->priv->modifier_mask << 1;
#line 817 "WindowSwitcher.c"
		}
	}
#line 211 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = self->priv->_opened;
#line 211 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!_tmp3_) {
#line 824 "WindowSwitcher.c"
		gboolean windows_exist = FALSE;
		const gchar* _tmp4_;
#line 213 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = meta_key_binding_get_name (binding);
#line 213 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (g_str_has_prefix (_tmp4_, "switch-group")) {
#line 831 "WindowSwitcher.c"
			MetaWorkspace* _tmp5_;
#line 214 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp5_ = workspace;
#line 214 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			windows_exist = gala_window_switcher_collect_current_windows (self, display, _tmp5_);
#line 837 "WindowSwitcher.c"
		} else {
			MetaWorkspace* _tmp6_;
#line 216 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp6_ = workspace;
#line 216 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			windows_exist = gala_window_switcher_collect_all_windows (self, display, _tmp6_);
#line 844 "WindowSwitcher.c"
		}
#line 219 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (!windows_exist) {
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_g_object_unref0 (workspace);
#line 220 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return;
#line 852 "WindowSwitcher.c"
		}
#line 223 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_open_switcher (self);
#line 856 "WindowSwitcher.c"
	}
#line 226 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = meta_key_binding_get_name (binding);
#line 226 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 226 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	binding_name = _tmp8_;
#line 227 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = binding_name;
#line 227 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	backward = g_str_has_suffix (_tmp9_, "-backward");
#line 229 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_next_window (self, backward);
#line 189 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (binding_name);
#line 189 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (workspace);
#line 874 "WindowSwitcher.c"
}

static Block72Data*
block72_data_ref (Block72Data* _data72_)
{
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_atomic_int_inc (&_data72_->_ref_count_);
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return _data72_;
#line 884 "WindowSwitcher.c"
}

static void
block72_data_unref (void * _userdata_)
{
	Block72Data* _data72_;
	_data72_ = (Block72Data*) _userdata_;
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (g_atomic_int_dec_and_test (&_data72_->_ref_count_)) {
#line 894 "WindowSwitcher.c"
		GalaWindowSwitcher* self;
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self = _data72_->self;
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (self);
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_slice_free (Block72Data, _data72_);
#line 902 "WindowSwitcher.c"
	}
}

static void
__lambda82_ (Block72Data* _data72_,
             gdouble percentage)
{
	GalaWindowSwitcher* self;
	gfloat window_index = 0.0F;
	ClutterActor* _tmp0_;
#line 247 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = _data72_->self;
#line 248 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	window_index = gala_gesture_tracker_animation_value ((gfloat) 0, (gfloat) GALA_WINDOW_SWITCHER_GESTURE_RANGE_LIMIT, percentage, TRUE);
#line 250 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->container;
#line 250 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (window_index >= ((gfloat) clutter_actor_get_n_children (_tmp0_))) {
#line 251 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 923 "WindowSwitcher.c"
	}
#line 254 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (window_index > ((gfloat) _data72_->last_window_index)) {
#line 255 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		while (TRUE) {
#line 929 "WindowSwitcher.c"
			gint _tmp1_;
#line 255 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!(((gfloat) _data72_->last_window_index) < window_index)) {
#line 255 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				break;
#line 935 "WindowSwitcher.c"
			}
#line 256 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			gala_window_switcher_next_window (self, _data72_->direction == GALA_GESTURE_DIRECTION_LEFT);
#line 257 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp1_ = _data72_->last_window_index;
#line 257 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_data72_->last_window_index = _tmp1_ + 1;
#line 943 "WindowSwitcher.c"
		}
	} else {
#line 259 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (window_index < ((gfloat) _data72_->last_window_index)) {
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			while (TRUE) {
#line 950 "WindowSwitcher.c"
				gint _tmp2_;
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (!(((gfloat) _data72_->last_window_index) > window_index)) {
#line 260 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					break;
#line 956 "WindowSwitcher.c"
				}
#line 261 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_next_window (self, _data72_->direction == GALA_GESTURE_DIRECTION_RIGHT);
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp2_ = _data72_->last_window_index;
#line 262 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_data72_->last_window_index = _tmp2_ - 1;
#line 964 "WindowSwitcher.c"
			}
		}
	}
}

static void
___lambda82__gala_gesture_tracker_on_update (gdouble percentage,
                                             gpointer self)
{
#line 247 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	__lambda82_ (self, percentage);
#line 976 "WindowSwitcher.c"
}

static void
__lambda83_ (GalaWindowSwitcher* self,
             gdouble percentage,
             gboolean cancel_action,
             gint calculated_duration)
{
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
#line 268 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->handling_gesture = FALSE;
#line 269 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 269 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 269 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_close_switcher (self, meta_display_get_current_time (_tmp1_), FALSE);
#line 995 "WindowSwitcher.c"
}

static void
___lambda83__gala_gesture_tracker_on_end (gdouble percentage,
                                          gboolean cancel_action,
                                          gint calculated_duration,
                                          gpointer self)
{
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	__lambda83_ ((GalaWindowSwitcher*) self, percentage, cancel_action, calculated_duration);
#line 1006 "WindowSwitcher.c"
}

void
gala_window_switcher_handle_gesture (GalaWindowSwitcher* self,
                                     GalaGestureDirection direction)
{
	Block72Data* _data72_;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* workspace_manager = NULL;
	MetaDisplay* _tmp2_;
	MetaWorkspaceManager* _tmp3_;
	MetaWorkspace* active_workspace = NULL;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
	gboolean windows_exist = FALSE;
	MetaDisplay* _tmp6_;
	MetaWorkspace* _tmp7_;
	gint _tmp8_ = 0;
	GalaGestureTrackerOnUpdate on_animation_update = NULL;
	gpointer on_animation_update_target;
	GDestroyNotify on_animation_update_target_destroy_notify;
	GalaGestureTrackerOnEnd on_animation_end = NULL;
	gpointer on_animation_end_target;
	GDestroyNotify on_animation_end_target_destroy_notify;
	GalaGestureTracker* _tmp9_;
	GalaGestureTrackerOnUpdate _tmp10_;
	gpointer _tmp10__target;
	GDestroyNotify _tmp10__target_destroy_notify;
	GalaGestureTrackerOnEnd _tmp11_;
	gpointer _tmp11__target;
	GDestroyNotify _tmp11__target_destroy_notify;
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data72_ = g_slice_new0 (Block72Data);
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data72_->_ref_count_ = 1;
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data72_->self = g_object_ref (self);
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data72_->direction = direction;
#line 233 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->handling_gesture = TRUE;
#line 235 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 235 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 235 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	display = _tmp1_;
#line 236 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = display;
#line 236 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = meta_display_get_workspace_manager (_tmp2_);
#line 236 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	workspace_manager = _tmp3_;
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = workspace_manager;
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 237 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	active_workspace = _tmp5_;
#line 239 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = display;
#line 239 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = active_workspace;
#line 239 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	windows_exist = gala_window_switcher_collect_all_windows (self, _tmp6_, _tmp7_);
#line 240 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!windows_exist) {
#line 241 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		block72_data_unref (_data72_);
#line 241 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_data72_ = NULL;
#line 241 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1084 "WindowSwitcher.c"
	}
#line 243 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_open_switcher (self);
#line 246 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_data72_->direction == GALA_GESTURE_DIRECTION_RIGHT) {
#line 246 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = 0;
#line 1092 "WindowSwitcher.c"
	} else {
#line 246 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = -1;
#line 1096 "WindowSwitcher.c"
	}
#line 246 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data72_->last_window_index = _tmp8_;
#line 247 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update = ___lambda82__gala_gesture_tracker_on_update;
#line 247 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target = block72_data_ref (_data72_);
#line 247 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target_destroy_notify = block72_data_unref;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end = ___lambda83__gala_gesture_tracker_on_end;
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target = g_object_ref (self);
#line 267 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target_destroy_notify = g_object_unref;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = self->priv->_gesture_tracker;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = on_animation_update;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10__target = on_animation_update_target;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10__target_destroy_notify = on_animation_update_target_destroy_notify;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update = NULL;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target = NULL;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target_destroy_notify = NULL;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = on_animation_end;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11__target = on_animation_end_target;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11__target_destroy_notify = on_animation_end_target_destroy_notify;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end = NULL;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target = NULL;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target_destroy_notify = NULL;
#line 272 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_gesture_tracker_connect_handlers (_tmp9_, NULL, NULL, NULL, _tmp10_, _tmp10__target, _tmp10__target_destroy_notify, _tmp11_, _tmp11__target, _tmp11__target_destroy_notify);
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(on_animation_end_target_destroy_notify == NULL) ? NULL : (on_animation_end_target_destroy_notify (on_animation_end_target), NULL);
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end = NULL;
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target = NULL;
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_end_target_destroy_notify = NULL;
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(on_animation_update_target_destroy_notify == NULL) ? NULL : (on_animation_update_target_destroy_notify (on_animation_update_target), NULL);
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update = NULL;
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target = NULL;
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	on_animation_update_target_destroy_notify = NULL;
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	block72_data_unref (_data72_);
#line 232 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data72_ = NULL;
#line 1160 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_collect_all_windows (GalaWindowSwitcher* self,
                                          MetaDisplay* display,
                                          MetaWorkspace* workspace)
{
	GList* windows = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	MetaWindow* current_window = NULL;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp3_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp5_;
	GList* _tmp6_;
	gboolean result;
#line 275 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 275 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (display != NULL, FALSE);
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = meta_display_get_tab_list (display, META_TAB_LIST_NORMAL, workspace);
#line 276 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	windows = _tmp0_;
#line 277 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = windows;
#line 277 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp1_ == NULL) {
#line 278 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = FALSE;
#line 278 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 278 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 1196 "WindowSwitcher.c"
	}
#line 281 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = meta_display_get_tab_current (display, META_TAB_LIST_NORMAL, workspace);
#line 281 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_window = _tmp2_;
#line 282 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = current_window;
#line 282 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ == NULL) {
#line 283 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_current_icon (self, NULL);
#line 1208 "WindowSwitcher.c"
	}
#line 286 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->container;
#line 286 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_width (_tmp4_, (gfloat) -1);
#line 287 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->container;
#line 287 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_destroy_all_children (_tmp5_);
#line 289 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = windows;
#line 1220 "WindowSwitcher.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 289 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		window_collection = _tmp6_;
#line 289 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1228 "WindowSwitcher.c"
			MetaWindow* window = NULL;
#line 289 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			window = (MetaWindow*) window_it->data;
#line 1232 "WindowSwitcher.c"
			{
				GalaWindowSwitcherIcon* icon = NULL;
				MetaWindow* _tmp7_;
				GalaWindowSwitcherIcon* _tmp8_;
				MetaWindow* _tmp9_;
				MetaWindow* _tmp10_;
				ClutterActor* _tmp12_;
				GalaWindowSwitcherIcon* _tmp13_;
#line 290 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp7_ = window;
#line 290 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp8_ = gala_window_switcher_icon_new (_tmp7_, GALA_WINDOW_SWITCHER_ICON_SIZE, self->priv->scaling_factor);
#line 290 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				g_object_ref_sink (_tmp8_);
#line 290 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				icon = _tmp8_;
#line 291 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp9_ = window;
#line 291 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp10_ = current_window;
#line 291 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (_tmp9_ == _tmp10_) {
#line 1255 "WindowSwitcher.c"
					GalaWindowSwitcherIcon* _tmp11_;
#line 292 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp11_ = icon;
#line 292 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					gala_window_switcher_set_current_icon (self, _tmp11_);
#line 1261 "WindowSwitcher.c"
				}
#line 295 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp12_ = self->priv->container;
#line 295 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp13_ = icon;
#line 295 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				clutter_actor_add_child (_tmp12_, (ClutterActor*) _tmp13_);
#line 289 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (icon);
#line 1271 "WindowSwitcher.c"
			}
		}
	}
#line 298 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 298 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 298 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1281 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_collect_current_windows (GalaWindowSwitcher* self,
                                              MetaDisplay* display,
                                              MetaWorkspace* workspace)
{
	GList* windows = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	MetaWindow* current_window = NULL;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp3_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp5_;
	GalaWindowTracker* window_tracker = NULL;
	GalaWindowManager* _tmp6_;
	GalaWindowTracker* _tmp7_;
	GalaWindowTracker* _tmp8_;
	GalaApp* app = NULL;
	GalaWindowTracker* _tmp9_;
	MetaWindow* _tmp10_;
	GalaApp* _tmp11_;
	GList* _tmp12_;
	gboolean result;
#line 301 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 301 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (display != NULL, FALSE);
#line 302 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = meta_display_get_tab_list (display, META_TAB_LIST_NORMAL, workspace);
#line 302 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	windows = _tmp0_;
#line 303 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = windows;
#line 303 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp1_ == NULL) {
#line 304 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = FALSE;
#line 304 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 304 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 1325 "WindowSwitcher.c"
	}
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = meta_display_get_tab_current (display, META_TAB_LIST_NORMAL, workspace);
#line 307 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_window = _tmp2_;
#line 308 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = current_window;
#line 308 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ == NULL) {
#line 309 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_current_icon (self, NULL);
#line 310 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = FALSE;
#line 310 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 310 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 1343 "WindowSwitcher.c"
	}
#line 313 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->container;
#line 313 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_width (_tmp4_, (gfloat) -1);
#line 314 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = self->priv->container;
#line 314 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_destroy_all_children (_tmp5_);
#line 316 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = self->priv->_wm;
#line 316 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = gala_window_manager_gala_get_window_tracker (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala));
#line 316 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = _tmp7_;
#line 316 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	window_tracker = _tmp8_;
#line 317 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = window_tracker;
#line 317 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = current_window;
#line 317 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = gala_window_tracker_get_app_for_window (_tmp9_, _tmp10_);
#line 317 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	app = _tmp11_;
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = windows;
#line 1371 "WindowSwitcher.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		window_collection = _tmp12_;
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1379 "WindowSwitcher.c"
			MetaWindow* window = NULL;
#line 318 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			window = (MetaWindow*) window_it->data;
#line 1383 "WindowSwitcher.c"
			{
				GalaWindowTracker* _tmp13_;
				MetaWindow* _tmp14_;
				GalaApp* _tmp15_;
				GalaApp* _tmp16_;
				GalaApp* _tmp17_;
				gboolean _tmp18_;
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp13_ = window_tracker;
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp14_ = window;
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp15_ = gala_window_tracker_get_app_for_window (_tmp13_, _tmp14_);
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp16_ = _tmp15_;
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp17_ = app;
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp18_ = _tmp16_ == _tmp17_;
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (_tmp16_);
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				if (_tmp18_) {
#line 1407 "WindowSwitcher.c"
					GalaWindowSwitcherIcon* icon = NULL;
					MetaWindow* _tmp19_;
					GalaWindowSwitcherIcon* _tmp20_;
					MetaWindow* _tmp21_;
					MetaWindow* _tmp22_;
					ClutterActor* _tmp24_;
					GalaWindowSwitcherIcon* _tmp25_;
#line 320 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp19_ = window;
#line 320 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp20_ = gala_window_switcher_icon_new (_tmp19_, GALA_WINDOW_SWITCHER_ICON_SIZE, self->priv->scaling_factor);
#line 320 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					g_object_ref_sink (_tmp20_);
#line 320 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					icon = _tmp20_;
#line 321 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp21_ = window;
#line 321 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp22_ = current_window;
#line 321 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					if (_tmp21_ == _tmp22_) {
#line 1429 "WindowSwitcher.c"
						GalaWindowSwitcherIcon* _tmp23_;
#line 322 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
						_tmp23_ = icon;
#line 322 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
						gala_window_switcher_set_current_icon (self, _tmp23_);
#line 1435 "WindowSwitcher.c"
					}
#line 325 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp24_ = self->priv->container;
#line 325 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_tmp25_ = icon;
#line 325 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					clutter_actor_add_child (_tmp24_, (ClutterActor*) _tmp25_);
#line 319 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
					_g_object_unref0 (icon);
#line 1445 "WindowSwitcher.c"
				}
			}
		}
	}
#line 329 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 329 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (app);
#line 329 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 329 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1458 "WindowSwitcher.c"
}

static void
gala_window_switcher_open_switcher (GalaWindowSwitcher* self)
{
	ClutterActor* _tmp0_;
	gboolean _tmp3_;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp4_;
	MetaDisplay* _tmp5_;
	gint monitor = 0;
	MetaDisplay* _tmp6_;
	MtkRectangle geom = {0};
	MetaDisplay* _tmp7_;
	MtkRectangle _tmp8_ = {0};
	gfloat container_width = 0.0F;
	ClutterActor* _tmp9_;
	ClutterActor* _tmp10_;
	gfloat _tmp11_;
	gfloat _tmp12_;
	ClutterActor* _tmp13_;
	gfloat _tmp14_;
	gfloat _tmp15_;
	gfloat _tmp16_ = 0.0F;
	MtkRectangle _tmp17_;
	gfloat nat_width = 0.0F;
	gfloat nat_height = 0.0F;
	ClutterActor* _tmp20_;
	gfloat _tmp21_ = 0.0F;
	gfloat _tmp22_ = 0.0F;
	gint switcher_height = 0;
	ClutterText* _tmp23_;
	gfloat _tmp24_;
	gfloat _tmp25_;
	ClutterActor* _tmp26_;
	gfloat _tmp27_;
	gfloat _tmp28_;
	ClutterCanvas* _tmp29_;
	ClutterCanvas* _tmp30_;
	MtkRectangle _tmp31_;
	MtkRectangle _tmp32_;
	gfloat _tmp33_;
	gfloat _tmp34_;
	MtkRectangle _tmp35_;
	MtkRectangle _tmp36_;
	gfloat _tmp37_;
	gfloat _tmp38_;
#line 332 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->container;
#line 333 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (clutter_actor_get_n_children (_tmp0_) == 0) {
#line 1512 "WindowSwitcher.c"
		ClutterBackend* _tmp1_;
		ClutterSeat* _tmp2_;
#line 334 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = clutter_get_default_backend ();
#line 334 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = clutter_backend_get_default_seat (_tmp1_);
#line 334 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		clutter_seat_bell_notify (_tmp2_);
#line 335 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1523 "WindowSwitcher.c"
	}
#line 338 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = self->priv->_opened;
#line 338 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_) {
#line 339 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1531 "WindowSwitcher.c"
	}
#line 342 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 344 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->_wm;
#line 344 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = meta_plugin_get_display ((MetaPlugin*) _tmp4_);
#line 344 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	display = _tmp5_;
#line 345 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = display;
#line 345 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	monitor = meta_display_get_current_monitor (_tmp6_);
#line 346 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = display;
#line 346 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	meta_display_get_monitor_geometry (_tmp7_, monitor, &_tmp8_);
#line 346 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	geom = _tmp8_;
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = self->priv->container;
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = self->priv->container;
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = clutter_actor_get_margin_left (_tmp10_);
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = _tmp11_;
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = self->priv->container;
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = clutter_actor_get_margin_right (_tmp13_);
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp15_ = _tmp14_;
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_get_preferred_width (_tmp9_, (gala_internal_utils_scale_to_int (GALA_WINDOW_SWITCHER_ICON_SIZE, self->priv->scaling_factor) + _tmp12_) + _tmp15_, NULL, &_tmp16_);
#line 349 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	container_width = _tmp16_;
#line 354 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp17_ = geom;
#line 354 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if ((container_width + (gala_internal_utils_scale_to_int (GALA_WINDOW_SWITCHER_MIN_OFFSET, self->priv->scaling_factor) * 2)) > ((gfloat) _tmp17_.width)) {
#line 1573 "WindowSwitcher.c"
		ClutterActor* _tmp18_;
		MtkRectangle _tmp19_;
#line 355 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp18_ = self->priv->container;
#line 355 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp19_ = geom;
#line 355 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		clutter_actor_set_width (_tmp18_, (gfloat) (_tmp19_.width - (gala_internal_utils_scale_to_int (GALA_WINDOW_SWITCHER_MIN_OFFSET, self->priv->scaling_factor) * 2)));
#line 1582 "WindowSwitcher.c"
	}
#line 359 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp20_ = self->priv->container;
#line 359 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_get_preferred_size (_tmp20_, NULL, NULL, &_tmp21_, &_tmp22_);
#line 359 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	nat_width = _tmp21_;
#line 359 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	nat_height = _tmp22_;
#line 361 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp23_ = self->priv->caption;
#line 361 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp24_ = clutter_actor_get_height ((ClutterActor*) _tmp23_);
#line 361 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp25_ = _tmp24_;
#line 361 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp26_ = self->priv->container;
#line 361 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp27_ = clutter_actor_get_margin_bottom (_tmp26_);
#line 361 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp28_ = _tmp27_;
#line 361 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switcher_height = (gint) (((nat_height + (_tmp25_ / 2)) - _tmp28_) + ((GALA_WINDOW_SWITCHER_WRAPPER_PADDING * 3) * self->priv->scaling_factor));
#line 362 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_size ((ClutterActor*) self, (gfloat) ((gint) nat_width), (gfloat) switcher_height);
#line 363 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp29_ = self->priv->canvas;
#line 363 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_canvas_set_size (_tmp29_, (gint) nat_width, switcher_height);
#line 364 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp30_ = self->priv->canvas;
#line 364 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_content_invalidate ((ClutterContent*) _tmp30_);
#line 367 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_update_caption_text (self);
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp31_ = geom;
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp32_ = geom;
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp33_ = clutter_actor_get_width ((ClutterActor*) self);
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp34_ = _tmp33_;
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp35_ = geom;
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp36_ = geom;
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp37_ = clutter_actor_get_height ((ClutterActor*) self);
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp38_ = _tmp37_;
#line 369 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_position ((ClutterActor*) self, (gfloat) ((gint) (_tmp31_.x + ((_tmp32_.width - _tmp34_) / 2))), (gfloat) ((gint) (_tmp35_.y + ((_tmp36_.height - _tmp38_) / 2))));
#line 374 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_toggle_display (self, TRUE);
#line 1638 "WindowSwitcher.c"
}

static void
gala_window_switcher_toggle_display (GalaWindowSwitcher* self,
                                     gboolean show)
{
	gboolean _tmp0_;
	gint _tmp3_ = 0;
	GalaWindowManager* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gint _tmp7_ = 0;
	ClutterActor* _tmp8_;
#line 377 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 378 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_opened;
#line 378 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_ == show) {
#line 379 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1660 "WindowSwitcher.c"
	}
#line 382 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_set_opened (self, show);
#line 383 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (show) {
#line 384 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_push_modal (self);
#line 1668 "WindowSwitcher.c"
	} else {
		GalaWindowManager* _tmp1_;
		GalaModalProxy* _tmp2_;
#line 386 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = self->priv->_wm;
#line 386 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = self->priv->modal_proxy;
#line 386 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_manager_pop_modal (_tmp1_, _tmp2_);
#line 1678 "WindowSwitcher.c"
	}
#line 389 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 390 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = self->priv->_wm;
#line 390 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = gala_window_manager_get_enable_animations (_tmp4_);
#line 390 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = _tmp5_;
#line 390 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp6_) {
#line 390 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = GALA_WINDOW_SWITCHER_ANIMATION_DURATION;
#line 1692 "WindowSwitcher.c"
	} else {
#line 390 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = 0;
#line 1696 "WindowSwitcher.c"
	}
#line 390 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, (guint) _tmp3_);
#line 391 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (show) {
#line 391 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp7_ = 255;
#line 1704 "WindowSwitcher.c"
	} else {
#line 391 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp7_ = 0;
#line 1708 "WindowSwitcher.c"
	}
#line 391 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) _tmp7_);
#line 392 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 394 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = self->priv->container;
#line 394 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_reactive (_tmp8_, show);
#line 1718 "WindowSwitcher.c"
}

static gboolean
__lambda81_ (GalaWindowSwitcher* self,
             MetaKeyBinding* binding)
{
	MetaKeyBindingAction action = 0;
	const gchar* _tmp0_;
	gboolean result;
#line 399 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 400 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 400 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	action = meta_prefs_get_keybinding_action (_tmp0_);
#line 402 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (action) {
#line 402 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_NONE:
#line 402 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_LOCATE_POINTER_KEY:
#line 402 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_APPLICATIONS:
#line 402 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_APPLICATIONS_BACKWARD:
#line 402 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_WINDOWS:
#line 402 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_WINDOWS_BACKWARD:
#line 402 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_GROUP:
#line 402 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case META_KEYBINDING_ACTION_SWITCH_GROUP_BACKWARD:
#line 1752 "WindowSwitcher.c"
		{
#line 411 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = FALSE;
#line 411 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 1758 "WindowSwitcher.c"
		}
		default:
		{
#line 413 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			break;
#line 1764 "WindowSwitcher.c"
		}
	}
#line 416 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 416 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1771 "WindowSwitcher.c"
}

static gboolean
___lambda81__gala_keybinding_filter (MetaKeyBinding* binding,
                                     gpointer self)
{
	gboolean result;
	result = __lambda81_ ((GalaWindowSwitcher*) self, binding);
#line 399 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 1782 "WindowSwitcher.c"
}

static void
gala_window_switcher_push_modal (GalaWindowSwitcher* self)
{
	GalaWindowManager* _tmp0_;
	GalaModalProxy* _tmp1_;
	GalaModalProxy* _tmp2_;
#line 397 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 398 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 398 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_manager_push_modal (_tmp0_, (ClutterActor*) self);
#line 398 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 398 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->modal_proxy = _tmp1_;
#line 399 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->modal_proxy;
#line 399 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_modal_proxy_set_keybinding_filter (_tmp2_, ___lambda81__gala_keybinding_filter, self);
#line 1805 "WindowSwitcher.c"
}

static void
gala_window_switcher_close_switcher (GalaWindowSwitcher* self,
                                     guint32 time,
                                     gboolean cancel)
{
	gboolean _tmp0_;
	MetaWindow* window = NULL;
	GalaWindowSwitcherIcon* _tmp1_;
	GalaWindowSwitcherIcon* _tmp2_;
	MetaWindow* _tmp3_;
	MetaWindow* _tmp4_;
	MetaWindow* _tmp5_;
	MetaWindow* _tmp6_;
#line 421 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 422 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_opened;
#line 422 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!_tmp0_) {
#line 423 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1829 "WindowSwitcher.c"
	}
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_switcher_get_current_icon (self);
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = gala_window_switcher_icon_get_window (_tmp2_);
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = _tmp3_;
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 426 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	window = _tmp5_;
#line 427 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = window;
#line 427 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp6_ == NULL) {
#line 428 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (window);
#line 428 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1851 "WindowSwitcher.c"
	}
#line 431 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!cancel) {
#line 1855 "WindowSwitcher.c"
		MetaWorkspace* workspace = NULL;
		MetaWindow* _tmp7_;
		MetaWorkspace* _tmp8_;
		MetaWorkspace* _tmp9_;
		GalaWindowManager* _tmp10_;
		MetaDisplay* _tmp11_;
		MetaWorkspaceManager* _tmp12_;
		MetaWorkspace* _tmp13_;
#line 432 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp7_ = window;
#line 432 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = meta_window_get_workspace (_tmp7_);
#line 432 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		workspace = _tmp8_;
#line 433 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp9_ = workspace;
#line 433 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = self->priv->_wm;
#line 433 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp11_ = meta_plugin_get_display ((MetaPlugin*) _tmp10_);
#line 433 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp12_ = meta_display_get_workspace_manager (_tmp11_);
#line 433 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp13_ = meta_workspace_manager_get_active_workspace (_tmp12_);
#line 433 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (_tmp9_ != _tmp13_) {
#line 1882 "WindowSwitcher.c"
			MetaWorkspace* _tmp14_;
			MetaWindow* _tmp15_;
#line 434 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp14_ = workspace;
#line 434 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp15_ = window;
#line 434 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			meta_workspace_activate_with_focus (_tmp14_, _tmp15_, time);
#line 1891 "WindowSwitcher.c"
		} else {
			MetaWindow* _tmp16_;
#line 436 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp16_ = window;
#line 436 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			meta_window_activate (_tmp16_, time);
#line 1898 "WindowSwitcher.c"
		}
	}
#line 440 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_toggle_display (self, FALSE);
#line 421 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (window);
#line 1905 "WindowSwitcher.c"
}

static void
gala_window_switcher_next_window (GalaWindowSwitcher* self,
                                  gboolean backward)
{
	ClutterActor* actor = NULL;
	gboolean _tmp0_ = FALSE;
	ClutterActor* _tmp1_;
	GalaWindowSwitcherIcon* _tmp6_;
	GalaWindowSwitcherIcon* _tmp7_;
	ClutterActor* _tmp27_;
#line 443 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = self->priv->container;
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (clutter_actor_get_n_children (_tmp1_) == 1) {
#line 1924 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp2_;
		GalaWindowSwitcherIcon* _tmp3_;
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = gala_window_switcher_get_current_icon (self);
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = _tmp2_;
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 1933 "WindowSwitcher.c"
	} else {
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 1937 "WindowSwitcher.c"
	}
#line 446 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 1941 "WindowSwitcher.c"
		ClutterBackend* _tmp4_;
		ClutterSeat* _tmp5_;
#line 447 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = clutter_get_default_backend ();
#line 447 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = clutter_backend_get_default_seat (_tmp4_);
#line 447 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		clutter_seat_bell_notify (_tmp5_);
#line 448 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 448 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return;
#line 1954 "WindowSwitcher.c"
	}
#line 451 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = gala_window_switcher_get_current_icon (self);
#line 451 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = _tmp6_;
#line 451 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp7_ == NULL) {
#line 1962 "WindowSwitcher.c"
		ClutterActor* _tmp8_;
		ClutterActor* _tmp9_;
		ClutterActor* _tmp10_;
#line 452 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = self->priv->container;
#line 452 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp9_ = clutter_actor_get_first_child (_tmp8_);
#line 452 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 452 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 452 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		actor = _tmp10_;
#line 1976 "WindowSwitcher.c"
	} else {
#line 453 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		if (!backward) {
#line 1980 "WindowSwitcher.c"
			GalaWindowSwitcherIcon* _tmp11_;
			GalaWindowSwitcherIcon* _tmp12_;
			ClutterActor* _tmp13_;
			ClutterActor* _tmp14_;
			ClutterActor* _tmp15_;
#line 454 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp11_ = gala_window_switcher_get_current_icon (self);
#line 454 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp12_ = _tmp11_;
#line 454 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp13_ = clutter_actor_get_next_sibling ((ClutterActor*) _tmp12_);
#line 454 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp14_ = _g_object_ref0 (_tmp13_);
#line 454 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_g_object_unref0 (actor);
#line 454 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			actor = _tmp14_;
#line 455 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp15_ = actor;
#line 455 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (_tmp15_ == NULL) {
#line 2002 "WindowSwitcher.c"
				ClutterActor* _tmp16_;
				ClutterActor* _tmp17_;
				ClutterActor* _tmp18_;
#line 456 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp16_ = self->priv->container;
#line 456 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp17_ = clutter_actor_get_first_child (_tmp16_);
#line 456 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp18_ = _g_object_ref0 (_tmp17_);
#line 456 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (actor);
#line 456 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				actor = _tmp18_;
#line 2016 "WindowSwitcher.c"
			}
		} else {
			GalaWindowSwitcherIcon* _tmp19_;
			GalaWindowSwitcherIcon* _tmp20_;
			ClutterActor* _tmp21_;
			ClutterActor* _tmp22_;
			ClutterActor* _tmp23_;
#line 459 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp19_ = gala_window_switcher_get_current_icon (self);
#line 459 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp20_ = _tmp19_;
#line 459 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp21_ = clutter_actor_get_previous_sibling ((ClutterActor*) _tmp20_);
#line 459 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp22_ = _g_object_ref0 (_tmp21_);
#line 459 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_g_object_unref0 (actor);
#line 459 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			actor = _tmp22_;
#line 460 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			_tmp23_ = actor;
#line 460 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (_tmp23_ == NULL) {
#line 2040 "WindowSwitcher.c"
				ClutterActor* _tmp24_;
				ClutterActor* _tmp25_;
				ClutterActor* _tmp26_;
#line 461 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp24_ = self->priv->container;
#line 461 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp25_ = clutter_actor_get_last_child (_tmp24_);
#line 461 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_tmp26_ = _g_object_ref0 (_tmp25_);
#line 461 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				_g_object_unref0 (actor);
#line 461 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				actor = _tmp26_;
#line 2054 "WindowSwitcher.c"
			}
		}
	}
#line 465 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp27_ = actor;
#line 465 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_set_current_icon (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GALA_TYPE_WINDOW_SWITCHER_ICON, GalaWindowSwitcherIcon));
#line 443 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (actor);
#line 2064 "WindowSwitcher.c"
}

static void
gala_window_switcher_update_caption_text (GalaWindowSwitcher* self)
{
	MetaWindow* _tmp0_ = NULL;
	GalaWindowSwitcherIcon* _tmp1_;
	GalaWindowSwitcherIcon* _tmp2_;
	MetaWindow* current_window = NULL;
	MetaWindow* _tmp7_;
	const gchar* _tmp8_ = NULL;
	MetaWindow* _tmp9_;
	gchar* current_caption = NULL;
	gchar* _tmp13_;
	ClutterText* _tmp14_;
	ClutterText* _tmp15_;
	gfloat _tmp16_;
	gfloat _tmp17_;
	ClutterText* _tmp18_;
	gfloat _tmp19_;
	gfloat _tmp20_;
	ClutterText* _tmp21_;
	gfloat _tmp22_;
	gfloat _tmp23_;
#line 468 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = gala_window_switcher_get_current_icon (self);
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_ != NULL) {
#line 2097 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp3_;
		GalaWindowSwitcherIcon* _tmp4_;
		MetaWindow* _tmp5_;
		MetaWindow* _tmp6_;
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = gala_window_switcher_get_current_icon (self);
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = _tmp3_;
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp5_ = gala_window_switcher_icon_get_window (_tmp4_);
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp6_ = _tmp5_;
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _tmp6_;
#line 2112 "WindowSwitcher.c"
	} else {
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = NULL;
#line 2116 "WindowSwitcher.c"
	}
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = _g_object_ref0 (_tmp0_);
#line 469 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_window = _tmp7_;
#line 470 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = current_window;
#line 470 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp9_ != NULL) {
#line 2126 "WindowSwitcher.c"
		MetaWindow* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 470 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp10_ = current_window;
#line 470 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp11_ = meta_window_get_title (_tmp10_);
#line 470 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp12_ = _tmp11_;
#line 470 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = _tmp12_;
#line 2138 "WindowSwitcher.c"
	} else {
#line 470 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp8_ = "n/a";
#line 2142 "WindowSwitcher.c"
	}
#line 470 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = g_strdup (_tmp8_);
#line 470 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	current_caption = _tmp13_;
#line 471 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = self->priv->caption;
#line 471 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_text_set_text (_tmp14_, current_caption);
#line 474 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp15_ = self->priv->caption;
#line 474 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp16_ = clutter_actor_get_width ((ClutterActor*) self);
#line 474 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp17_ = _tmp16_;
#line 474 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_width ((ClutterActor*) _tmp15_, _tmp17_ - ((GALA_WINDOW_SWITCHER_WRAPPER_PADDING * 2) * self->priv->scaling_factor));
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp18_ = self->priv->caption;
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp19_ = clutter_actor_get_height ((ClutterActor*) self);
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp20_ = _tmp19_;
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp21_ = self->priv->caption;
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp22_ = clutter_actor_get_height ((ClutterActor*) _tmp21_);
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp23_ = _tmp22_;
#line 475 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_position ((ClutterActor*) _tmp18_, (gfloat) gala_internal_utils_scale_to_int (GALA_WINDOW_SWITCHER_WRAPPER_PADDING, self->priv->scaling_factor), (gfloat) ((gint) ((_tmp20_ - (_tmp23_ / 2)) - (gala_internal_utils_scale_to_int (GALA_WINDOW_SWITCHER_WRAPPER_PADDING, self->priv->scaling_factor) * 2))));
#line 468 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (current_caption);
#line 468 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (current_window);
#line 2178 "WindowSwitcher.c"
}

static void
gala_window_switcher_real_key_focus_out (ClutterActor* base)
{
	GalaWindowSwitcher * self;
#line 481 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 482 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (!self->priv->handling_gesture) {
#line 2189 "WindowSwitcher.c"
		GalaWindowManager* _tmp0_;
		MetaDisplay* _tmp1_;
#line 483 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = self->priv->_wm;
#line 483 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 483 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_close_switcher (self, meta_display_get_current_time (_tmp1_), FALSE);
#line 2198 "WindowSwitcher.c"
	}
}

static gboolean
gala_window_switcher_container_motion_event (GalaWindowSwitcher* self,
                                             ClutterEvent* event)
{
	gfloat x = 0.0F;
	gfloat y = 0.0F;
	gfloat _tmp0_ = 0.0F;
	gfloat _tmp1_ = 0.0F;
	ClutterActor* actor = NULL;
	ClutterActor* _tmp2_;
	ClutterStage* _tmp3_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	GalaWindowSwitcherIcon* selected = NULL;
	ClutterActor* _tmp7_;
	GalaWindowSwitcherIcon* _tmp8_;
	GalaWindowSwitcherIcon* _tmp9_;
	GalaWindowSwitcherIcon* _tmp10_;
	GalaWindowSwitcherIcon* _tmp11_;
	GalaWindowSwitcherIcon* _tmp12_;
	gboolean result;
#line 488 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 488 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 492 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (self->priv->handling_gesture) {
#line 493 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = CLUTTER_EVENT_STOP;
#line 493 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 2234 "WindowSwitcher.c"
	}
#line 497 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_event_get_coords (event, &_tmp0_, &_tmp1_);
#line 497 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	x = _tmp0_;
#line 497 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	y = _tmp1_;
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->container;
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = clutter_actor_get_stage (_tmp2_);
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = clutter_stage_get_actor_at_pos (_tmp3_, CLUTTER_PICK_ALL, (gfloat) ((gint) x), (gfloat) ((gint) y));
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 498 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	actor = _tmp5_;
#line 499 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = actor;
#line 499 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp6_ == NULL) {
#line 500 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = CLUTTER_EVENT_STOP;
#line 500 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 500 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 2262 "WindowSwitcher.c"
	}
#line 503 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = actor;
#line 503 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = _g_object_ref0 (GALA_IS_WINDOW_SWITCHER_ICON (_tmp7_) ? ((GalaWindowSwitcherIcon*) _tmp7_) : NULL);
#line 503 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	selected = _tmp8_;
#line 504 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = selected;
#line 504 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp9_ == NULL) {
#line 505 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		result = CLUTTER_EVENT_STOP;
#line 505 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (selected);
#line 505 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 505 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		return result;
#line 2282 "WindowSwitcher.c"
	}
#line 508 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = gala_window_switcher_get_current_icon (self);
#line 508 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = _tmp10_;
#line 508 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = selected;
#line 508 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp11_ != _tmp12_) {
#line 2292 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp13_;
#line 509 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp13_ = selected;
#line 509 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_current_icon (self, _tmp13_);
#line 2298 "WindowSwitcher.c"
	}
#line 512 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 512 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (selected);
#line 512 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (actor);
#line 512 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2308 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_container_mouse_release (GalaWindowSwitcher* self,
                                              ClutterEvent* event)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean result;
#line 516 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 516 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 520 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = self->priv->_opened;
#line 520 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp2_) {
#line 520 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = clutter_event_get_button (event) == CLUTTER_BUTTON_PRIMARY;
#line 2329 "WindowSwitcher.c"
	} else {
#line 520 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = FALSE;
#line 2333 "WindowSwitcher.c"
	}
#line 520 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp1_) {
#line 520 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = !self->priv->handling_gesture;
#line 2339 "WindowSwitcher.c"
	} else {
#line 520 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 2343 "WindowSwitcher.c"
	}
#line 520 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 521 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_close_switcher (self, clutter_event_get_time (event), FALSE);
#line 2349 "WindowSwitcher.c"
	}
#line 524 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = TRUE;
#line 524 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2355 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_real_key_release_event (ClutterActor* base,
                                             ClutterEvent* event)
{
	GalaWindowSwitcher * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 528 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 528 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 532 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if ((gala_window_switcher_get_current_modifiers (self) & self->priv->modifier_mask) == 0) {
#line 532 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = !self->priv->handling_gesture;
#line 2373 "WindowSwitcher.c"
	} else {
#line 532 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 2377 "WindowSwitcher.c"
	}
#line 532 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_) {
#line 533 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_close_switcher (self, clutter_event_get_time (event), FALSE);
#line 2383 "WindowSwitcher.c"
	}
#line 536 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 536 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2389 "WindowSwitcher.c"
}

static gboolean
gala_window_switcher_real_key_press_event (ClutterActor* base,
                                           ClutterEvent* event)
{
	GalaWindowSwitcher * self;
	gboolean result;
#line 540 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 540 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 544 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (clutter_event_get_key_symbol (event)) {
#line 544 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Right:
#line 2406 "WindowSwitcher.c"
		{
#line 546 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!self->priv->handling_gesture) {
#line 547 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_next_window (self, FALSE);
#line 2412 "WindowSwitcher.c"
			}
#line 549 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_STOP;
#line 549 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2418 "WindowSwitcher.c"
		}
#line 544 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Left:
#line 2422 "WindowSwitcher.c"
		{
#line 551 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			if (!self->priv->handling_gesture) {
#line 552 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
				gala_window_switcher_next_window (self, TRUE);
#line 2428 "WindowSwitcher.c"
			}
#line 554 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_STOP;
#line 554 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2434 "WindowSwitcher.c"
		}
#line 544 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Escape:
#line 2438 "WindowSwitcher.c"
		{
#line 556 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			gala_window_switcher_close_switcher (self, clutter_event_get_time (event), TRUE);
#line 557 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_PROPAGATE;
#line 557 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2446 "WindowSwitcher.c"
		}
#line 544 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case CLUTTER_KEY_Return:
#line 2450 "WindowSwitcher.c"
		{
#line 559 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			gala_window_switcher_close_switcher (self, clutter_event_get_time (event), FALSE);
#line 560 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			result = CLUTTER_EVENT_PROPAGATE;
#line 560 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
			return result;
#line 2458 "WindowSwitcher.c"
		}
		default:
#line 544 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 2463 "WindowSwitcher.c"
	}
#line 563 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 563 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2469 "WindowSwitcher.c"
}

static inline ClutterModifierType
gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self)
{
	ClutterModifierType modifiers = 0U;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaCursorTracker* _tmp2_;
	ClutterModifierType _tmp3_ = 0U;
	ClutterModifierType result;
#line 567 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 569 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 569 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 569 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = meta_cursor_tracker_get_for_display (_tmp1_);
#line 569 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	meta_cursor_tracker_get_pointer (_tmp2_, NULL, &_tmp3_);
#line 569 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	modifiers = _tmp3_;
#line 571 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = modifiers & CLUTTER_MODIFIER_MASK;
#line 571 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2497 "WindowSwitcher.c"
}

GalaWindowManager*
gala_window_switcher_get_wm (GalaWindowSwitcher* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = _tmp0_;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2513 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_wm (GalaWindowSwitcher* self,
                             GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	old_value = gala_window_switcher_get_wm (self);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (old_value != value) {
#line 2527 "WindowSwitcher.c"
		GalaWindowManager* _tmp0_;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->_wm);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->_wm = _tmp0_;
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM_PROPERTY]);
#line 2537 "WindowSwitcher.c"
	}
}

GalaGestureTracker*
gala_window_switcher_get_gesture_tracker (GalaWindowSwitcher* self)
{
	GalaGestureTracker* result;
	GalaGestureTracker* _tmp0_;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_gesture_tracker;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = _tmp0_;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2554 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_gesture_tracker (GalaWindowSwitcher* self,
                                          GalaGestureTracker* value)
{
	GalaGestureTracker* old_value;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	old_value = gala_window_switcher_get_gesture_tracker (self);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (old_value != value) {
#line 2568 "WindowSwitcher.c"
		GalaGestureTracker* _tmp0_;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->_gesture_tracker);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->_gesture_tracker = _tmp0_;
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY]);
#line 2578 "WindowSwitcher.c"
	}
}

gboolean
gala_window_switcher_get_opened (GalaWindowSwitcher* self)
{
	gboolean result;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = self->priv->_opened;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2592 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_opened (GalaWindowSwitcher* self,
                                 gboolean value)
{
	gboolean old_value;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	old_value = gala_window_switcher_get_opened (self);
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (old_value != value) {
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->_opened = value;
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_OPENED_PROPERTY]);
#line 2610 "WindowSwitcher.c"
	}
}

static GalaWindowSwitcherIcon*
gala_window_switcher_get_current_icon (GalaWindowSwitcher* self)
{
	GalaWindowSwitcherIcon* result;
	GalaWindowSwitcherIcon* _tmp0_;
#line 38 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_current_icon;
#line 39 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	result = _tmp0_;
#line 39 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2627 "WindowSwitcher.c"
}

static void
gala_window_switcher_set_current_icon (GalaWindowSwitcher* self,
                                       GalaWindowSwitcherIcon* value)
{
	GalaWindowSwitcherIcon* _tmp0_;
	GalaWindowSwitcherIcon* _tmp2_;
	GalaWindowSwitcherIcon* _tmp3_;
#line 41 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->_current_icon;
#line 42 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp0_ != NULL) {
#line 2643 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp1_;
#line 43 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp1_ = self->priv->_current_icon;
#line 43 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_icon_set_selected (_tmp1_, FALSE);
#line 2649 "WindowSwitcher.c"
	}
#line 46 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 46 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_current_icon);
#line 46 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->_current_icon = _tmp2_;
#line 47 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = self->priv->_current_icon;
#line 47 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (_tmp3_ != NULL) {
#line 2661 "WindowSwitcher.c"
		GalaWindowSwitcherIcon* _tmp4_;
#line 48 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp4_ = self->priv->_current_icon;
#line 48 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_icon_set_selected (_tmp4_, TRUE);
#line 2667 "WindowSwitcher.c"
	}
#line 51 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_update_caption_text (self);
#line 2671 "WindowSwitcher.c"
}

static Block73Data*
block73_data_ref (Block73Data* _data73_)
{
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_atomic_int_inc (&_data73_->_ref_count_);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return _data73_;
#line 2681 "WindowSwitcher.c"
}

static void
block73_data_unref (void * _userdata_)
{
	Block73Data* _data73_;
	_data73_ = (Block73Data*) _userdata_;
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (g_atomic_int_dec_and_test (&_data73_->_ref_count_)) {
#line 2691 "WindowSwitcher.c"
		GalaWindowSwitcher* self;
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self = _data73_->self;
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (_data73_->effect);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_g_object_unref0 (self);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_slice_free (Block73Data, _data73_);
#line 2701 "WindowSwitcher.c"
	}
}

static void
_gala_window_switcher___lambda84_ (GalaWindowSwitcher* self)
{
	ClutterCanvas* _tmp0_;
#line 89 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->canvas;
#line 89 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_content_invalidate ((ClutterContent*) _tmp0_);
#line 90 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_create_components (self);
#line 2715 "WindowSwitcher.c"
}

static void
__gala_window_switcher___lambda84__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 88 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_gala_window_switcher___lambda84_ ((GalaWindowSwitcher*) self);
#line 2725 "WindowSwitcher.c"
}

static void
_gala_window_switcher___lambda85_ (GalaWindowSwitcher* self)
{
	ClutterCanvas* _tmp0_;
#line 94 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = self->priv->canvas;
#line 94 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_content_invalidate ((ClutterContent*) _tmp0_);
#line 95 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_create_components (self);
#line 2738 "WindowSwitcher.c"
}

static void
__gala_window_switcher___lambda85__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 93 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_gala_window_switcher___lambda85_ ((GalaWindowSwitcher*) self);
#line 2748 "WindowSwitcher.c"
}

static void
_gala_window_switcher___lambda86_ (Block73Data* _data73_)
{
	GalaWindowSwitcher* self;
	gfloat cur_scale = 0.0F;
	MetaDisplay* _tmp0_;
	MetaDisplay* _tmp1_;
#line 99 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = _data73_->self;
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = _data73_->display;
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = _data73_->display;
#line 100 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	cur_scale = meta_display_get_monitor_scale (_tmp0_, meta_display_get_current_monitor (_tmp1_));
#line 101 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	if (cur_scale != self->priv->scaling_factor) {
#line 2768 "WindowSwitcher.c"
		ClutterCanvas* _tmp2_;
		GalaShadowEffect* _tmp3_;
#line 102 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		self->priv->scaling_factor = cur_scale;
#line 103 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp2_ = self->priv->canvas;
#line 103 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		clutter_canvas_set_scale_factor (_tmp2_, self->priv->scaling_factor);
#line 104 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		_tmp3_ = _data73_->effect;
#line 104 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_shadow_effect_set_scale_factor (_tmp3_, self->priv->scaling_factor);
#line 105 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_create_components (self);
#line 2783 "WindowSwitcher.c"
	}
}

static void
__gala_window_switcher___lambda86__meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                          gpointer self)
{
#line 99 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_gala_window_switcher___lambda86_ (self);
#line 2793 "WindowSwitcher.c"
}

static gboolean
_gala_window_switcher_draw_clutter_canvas_draw (ClutterCanvas* _sender,
                                                cairo_t* cr,
                                                gint width,
                                                gint height,
                                                gpointer self)
{
	gboolean result;
	result = gala_window_switcher_draw ((GalaWindowSwitcher*) self, cr, width, height);
#line 109 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return result;
#line 2807 "WindowSwitcher.c"
}

static GObject *
gala_window_switcher_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowSwitcher * self;
	Block73Data* _data73_;
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp0_;
	GraniteSettings* _tmp1_;
	GraniteSettings* _tmp2_;
	GalaWindowManager* _tmp3_;
	MetaDisplay* _tmp4_;
	MetaDisplay* _tmp5_;
	MetaDisplay* _tmp6_;
	ClutterCanvas* _tmp7_;
	ClutterCanvas* _tmp8_;
	ClutterCanvas* _tmp9_;
	gchar* _tmp10_;
	GalaShadowEffect* _tmp11_ = NULL;
	GalaShadowEffect* _tmp12_;
	GraniteSettings* _tmp13_;
	GtkSettings* _tmp14_;
	MetaMonitorManager* monitor_manager = NULL;
	GalaWindowManager* _tmp15_;
	MetaDisplay* _tmp16_;
	MetaContext* _tmp17_;
	MetaBackend* _tmp18_;
	MetaMonitorManager* _tmp19_;
	MetaMonitorManager* _tmp20_;
	ClutterCanvas* _tmp21_;
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	parent_class = G_OBJECT_CLASS (gala_window_switcher_parent_class);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data73_ = g_slice_new0 (Block73Data);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data73_->_ref_count_ = 1;
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data73_->self = g_object_ref (self);
#line 65 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 65 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gtk_settings = _tmp0_;
#line 66 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp1_ = granite_settings_get_default ();
#line 66 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 66 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->granite_settings);
#line 66 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->granite_settings = _tmp2_;
#line 68 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp3_ = self->priv->_wm;
#line 68 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp4_ = meta_plugin_get_display ((MetaPlugin*) _tmp3_);
#line 68 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data73_->display = _tmp4_;
#line 69 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp5_ = _data73_->display;
#line 69 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp6_ = _data73_->display;
#line 69 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->scaling_factor = meta_display_get_monitor_scale (_tmp5_, meta_display_get_current_monitor (_tmp6_));
#line 71 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp7_ = (ClutterCanvas*) clutter_canvas_new ();
#line 71 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->canvas);
#line 71 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->canvas = _tmp7_;
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp8_ = self->priv->canvas;
#line 72 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_canvas_set_scale_factor (_tmp8_, self->priv->scaling_factor);
#line 73 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp9_ = self->priv->canvas;
#line 73 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_content ((ClutterActor*) self, (ClutterContent*) _tmp9_);
#line 75 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 78 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_create_components (self);
#line 80 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp10_ = g_strdup ("window-switcher");
#line 80 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp11_ = gala_shadow_effect_new (40);
#line 80 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_shadow_effect_set_shadow_opacity (_tmp11_, (guint8) 200);
#line 80 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_shadow_effect_set_css_class (_tmp11_, _tmp10_);
#line 80 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_free0 (_tmp10_);
#line 80 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_shadow_effect_set_scale_factor (_tmp11_, self->priv->scaling_factor);
#line 80 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_ref_sink (_tmp11_);
#line 80 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data73_->effect = _tmp11_;
#line 85 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp12_ = _data73_->effect;
#line 85 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	clutter_actor_add_effect ((ClutterActor*) self, (ClutterEffect*) _tmp12_);
#line 88 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp13_ = self->priv->granite_settings;
#line 88 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) _tmp13_, "notify::prefers-color-scheme", (GCallback) __gala_window_switcher___lambda84__g_object_notify, self, 0);
#line 93 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp14_ = gtk_settings;
#line 93 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) _tmp14_, "notify::gtk-theme-name", (GCallback) __gala_window_switcher___lambda85__g_object_notify, self, 0);
#line 98 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp15_ = self->priv->_wm;
#line 98 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp16_ = meta_plugin_get_display ((MetaPlugin*) _tmp15_);
#line 98 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp17_ = meta_display_get_context (_tmp16_);
#line 98 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp18_ = meta_context_get_backend (_tmp17_);
#line 98 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp19_ = meta_backend_get_monitor_manager (_tmp18_);
#line 98 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	monitor_manager = _tmp19_;
#line 99 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp20_ = monitor_manager;
#line 99 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_data (_tmp20_, "monitors-changed", (GCallback) __gala_window_switcher___lambda86__meta_monitor_manager_monitors_changed, block73_data_ref (_data73_), (GClosureNotify) block73_data_unref, 0);
#line 109 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_tmp21_ = self->priv->canvas;
#line 109 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_signal_connect_object (_tmp21_, "draw", (GCallback) _gala_window_switcher_draw_clutter_canvas_draw, self, 0);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	block73_data_unref (_data73_);
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_data73_ = NULL;
#line 64 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	return obj;
#line 2951 "WindowSwitcher.c"
}

static void
gala_window_switcher_class_init (GalaWindowSwitcherClass * klass,
                                 gpointer klass_data)
{
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	gala_window_switcher_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowSwitcher_private_offset);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_focus_out = (void (*) (ClutterActor*)) gala_window_switcher_real_key_focus_out;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_release_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_switcher_real_key_release_event;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_press_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_switcher_real_key_press_event;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_switcher_get_property;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_switcher_set_property;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_switcher_constructor;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_switcher_finalize;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_WM_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY] = g_param_spec_object ("gesture-tracker", "gesture-tracker", "gesture-tracker", GALA_TYPE_GESTURE_TRACKER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_OPENED_PROPERTY, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_OPENED_PROPERTY] = g_param_spec_boolean ("opened", "opened", "opened", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2982 "WindowSwitcher.c"
}

static void
gala_window_switcher_instance_init (GalaWindowSwitcher * self,
                                    gpointer klass)
{
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv = gala_window_switcher_get_instance_private (self);
#line 22 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->_opened = FALSE;
#line 24 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->handling_gesture = FALSE;
#line 26 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->modal_proxy = NULL;
#line 34 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->dark_style_provider = NULL;
#line 36 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->_current_icon = NULL;
#line 55 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self->priv->scaling_factor = 1.0f;
#line 3003 "WindowSwitcher.c"
}

static void
gala_window_switcher_finalize (GObject * obj)
{
	GalaWindowSwitcher * self;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 20 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_wm);
#line 21 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_gesture_tracker);
#line 26 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 27 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->granite_settings);
#line 28 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->canvas);
#line 29 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->container);
#line 30 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->caption);
#line 32 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_gtk_widget_path_unref0 (self->priv->widget_path);
#line 33 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->style_context);
#line 36 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_current_icon);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	G_OBJECT_CLASS (gala_window_switcher_parent_class)->finalize (obj);
#line 3034 "WindowSwitcher.c"
}

static GType
gala_window_switcher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowSwitcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_switcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowSwitcher), 0, (GInstanceInitFunc) gala_window_switcher_instance_init, NULL };
	GType gala_window_switcher_type_id;
	gala_window_switcher_type_id = g_type_register_static (clutter_actor_get_type (), "GalaWindowSwitcher", &g_define_type_info, 0);
	GalaWindowSwitcher_private_offset = g_type_add_instance_private (gala_window_switcher_type_id, sizeof (GalaWindowSwitcherPrivate));
	return gala_window_switcher_type_id;
}

GType
gala_window_switcher_get_type (void)
{
	static volatile gsize gala_window_switcher_type_id__once = 0;
	if (g_once_init_enter (&gala_window_switcher_type_id__once)) {
		GType gala_window_switcher_type_id;
		gala_window_switcher_type_id = gala_window_switcher_get_type_once ();
		g_once_init_leave (&gala_window_switcher_type_id__once, gala_window_switcher_type_id);
	}
	return gala_window_switcher_type_id__once;
}

static void
_vala_gala_window_switcher_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (property_id) {
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_WM_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_value_set_object (value, gala_window_switcher_get_wm (self));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_value_set_object (value, gala_window_switcher_get_gesture_tracker (self));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_OPENED_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		g_value_set_boolean (value, gala_window_switcher_get_opened (self));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 3087 "WindowSwitcher.c"
		default:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 3093 "WindowSwitcher.c"
	}
}

static void
_vala_gala_window_switcher_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
	switch (property_id) {
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_WM_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_wm (self, g_value_get_object (value));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_GESTURE_TRACKER_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_gesture_tracker (self, g_value_get_object (value));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_OPENED_PROPERTY:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		gala_window_switcher_set_opened (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 3125 "WindowSwitcher.c"
		default:
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/WindowSwitcher/WindowSwitcher.vala"
		break;
#line 3131 "WindowSwitcher.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 21 "../src/PluginManager.vala"
	if (mem && byte_size != 0) {
#line 21 "../src/PluginManager.vala"
		new_mem = g_malloc (byte_size);
#line 21 "../src/PluginManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 3146 "WindowSwitcher.c"
	} else {
#line 21 "../src/PluginManager.vala"
		new_mem = NULL;
#line 3150 "WindowSwitcher.c"
	}
#line 21 "../src/PluginManager.vala"
	return new_mem;
#line 3154 "WindowSwitcher.c"
}

